"	***** Smalltalk chunk source generated June 12, 2000 at 5:54:45 pm *****	"!

"
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the 'License'); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an 'AS
IS' basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Fileout Generation.

The Initial Developer of the Original Code is Paul Baumann.  
Portions created by Paul Baumann are
Copyright (C) 2000, Paul L. Baumann.  All
Rights Reserved.

Contributor(s):

"!

"	***** Prerequisites *****	
		CstMessengerSupport 2.8
"!

"	***** Included versions *****	"!
"	PlbFileoutGeneration 2.1 002		"!

"	***** Class declarations *****	"!

Object subclass: #SfgChunkWriteStrategy
	instanceVariableNames: 'lastVisited stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

Object subclass: #SfgCodeInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgClassInitialization
	instanceVariableNames: 'realClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgClassInterface
	instanceVariableNames: 'chunkGroup realClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgGroupInterface
	instanceVariableNames: 'realGroup '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgMethodInterface
	instanceVariableNames: 'realMethod chunkGroup category '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgNamespaceVariableDefinition
	instanceVariableNames: 'namespace name initialValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgNotice
	instanceVariableNames: 'noticeString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgPostloadCode
	instanceVariableNames: 'sourceString chunkGroup '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

SfgCodeInterface subclass: #SfgPreloadCode
	instanceVariableNames: 'sourceString chunkGroup '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!

Object subclass: #SfgEnvyReadStrategy
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbFileoutGeneration'!


"	***** Behavior declarations *****	"!

!SfgChunkWriteStrategy methodsFor: 'printing'!

betterDelimitersFor: aString
	"VW will double-space source strings from compiled code.
	 This is an attempt to avoid screwed-up output."
	| rStream wStream |
	rStream := ReadStream on: aString.
	wStream := WriteStream on: String new.
	[ rStream atEnd ] whileFalse: [ 
		wStream nextPutAll: (rStream nextLine); cr.
		(rStream atEnd not and: [rStream peek asInteger = 10]) 
			ifTrue: [rStream next].
	].
	^wStream contents!

fixupSource: aString
	(aString includes: $!!) ifFalse: [^aString].
	^aString
		copyReplaceAll: '!!'
		with: '!!!!'! !

!SfgChunkWriteStrategy methodsFor: 'initialization'!

initialize
	stream := WriteStream on: String new.! !

!SfgChunkWriteStrategy methodsFor: 'accessors'!

lastVisited
	^lastVisited!

lastVisited: anObject
	lastVisited := anObject! !

!SfgChunkWriteStrategy methodsFor: 'printing-detail'!

printClass: aChunk

	| defType |
	self printTransitionTo: aChunk.
	defType := aChunk realClassIsVariable
		ifFalse: [ #subclass: ]
		ifTrue: [ aChunk realClassIsBytes
			ifTrue: [ #variableBytes: ]
			ifFalse: [ #variableSubclass: ]
		].
	self cstMessenger
		print: '\\%1 %2 #%3\	instanceVariableNames: ''%4''\	classVariableNames: ''%5''\	poolDictionaries: ''%6''\	category: ''%7''!!'
		on: self stream
		withArguments: (
			OrderedCollection new
			add: aChunk realSuperclass;
			add: defType;
			add: aChunk realClass;
			add: aChunk instVarNameString;
			add: aChunk classVarNameString;
			add: aChunk sharedPoolNameString;
			add: (self fixupSource: aChunk categoryString);
			yourself
		).
	aChunk classInstVarNameString isEmpty ifFalse: [
		self cstMessenger
		print: '\\%1 class instanceVariableNames: ''%2''!!'
		on: self stream
		withArguments: (
			Array
			with: aChunk realClass
			with: aChunk classInstVarNameString
		).
	].
	lastVisited := aChunk.!

printClassInitialization: aChunk

	self printTransitionTo: aChunk.
	self cstMessenger
		print: '\%1 %2.!!'
		on: self stream
		withArguments: (
			Array
			with: aChunk realClassName
			with: #initialize
		).
	lastVisited := aChunk.!

printCode: aChunk
	self printTransitionTo: aChunk.
	"Do nothing by default."
	lastVisited := aChunk.! !

!SfgChunkWriteStrategy methodsFor: 'printing-last'!

printedLastClass: aChunk
	"Do nothing by default."!

printedLastClassInitialization: aChunk
	"Do nothing by default."!

printedLastCode: aChunk
	"Do nothing by default."!

printedLastGroup: aChunk
	"Do nothing by default."!

printedLastMethod: aChunk
	self printedLastMethodGroup: aChunk.!

printedLastMethodGroup: aChunk
	self stream nextPutAll: ' !!'.!

printedLastNotice: aChunk
	"Do nothing by default."!

printedLastPostloadCode: aChunk
	"Do nothing by default."!

printedLastPreloadCode: aChunk
	"Do nothing by default."!

printedLastVariable: aChunk
	"Do nothing by default."! !

!SfgChunkWriteStrategy methodsFor: 'printing-first'!

printFirstClass: aChunk
	self stream cr; cr;
		nextPutAll: '"	***** Class declarations *****	"!!'.!

printFirstClassInitialization: aChunk
	self stream cr; cr; cr;
		nextPutAll: '"	***** Class initialization *****	"!!'; cr.!

printFirstCode: aChunk
	"Do nothing by default."!

printFirstGroup: aChunk

	| pre |
	pre := aChunk groupPrerequisites.
	pre isEmpty ifFalse: [
		self stream cr; cr;
			nextPutAll: '"	***** Prerequisites *****	'.
		pre do: [:ea | self stream cr; tab; tab; nextPutAll: ea signature ].
		self stream cr; nextPutAll: '"!!'.
	].
	self stream cr; cr;
		nextPutAll: '"	***** Included versions *****	"!!'.!

printFirstMethod: aChunk
	self stream cr; cr; cr;
		nextPutAll: '"	***** Behavior declarations *****	"!!'.!

printFirstNotice: aChunk
	"Do nothing by default."!

printFirstPostloadCode: aChunk
	self stream cr; cr; nextPutAll: '"	***** Post-load code *****	"!!'!

printFirstPreloadCode: aChunk
	self stream cr; cr; nextPutAll: '"	***** Pre-load code *****	"!!'!

printFirstVariable: aChunk
	self stream cr; cr;
		nextPutAll: '"	***** Namespace variable declarations *****	"!!'; cr.! !

!SfgChunkWriteStrategy methodsFor: 'printing-last'!

printFooter
	self stream cr; nextPutAll: '"	***** End of file *****	"!!'.! !

!SfgChunkWriteStrategy methodsFor: 'printing-detail'!

printGroup: aChunk

	self printTransitionTo: aChunk.
	self stream cr; nextPutAll: '"	'.
	aChunk parentGroupCount timesRepeat: [self stream tab].
	self stream nextPutAll: (self fixupSource: aChunk groupSignature).
	self stream nextPutAll: '		"!!'.
	lastVisited := aChunk.! !

!SfgChunkWriteStrategy methodsFor: 'printing-first'!

printHeading
	"Note: Avoid any whitespace as the first line of the file, Dolphin
	 won't be able to read the entire file and doesn't let you know what
	 the problem is."

	self cstMessenger
		print: '"	***** Smalltalk chunk source generated %1 at %2 *****	"!!'
		on: self stream
		withArguments: (
			Array with: Date today with: Time now
		).! !

!SfgChunkWriteStrategy methodsFor: 'printing'!

printItem: anItem on: aStream
	self stream: aStream.
	anItem printStrategy: self.
!

printItems: newItems on: aStream
	self stream: aStream.
	self printHeading.
	newItems asSortedCollection asArray 
		do: [:ea | ea printStrategy: self ].
	self printFooter.! !

!SfgChunkWriteStrategy methodsFor: 'printing-detail'!

printMethod: aChunk

	self printTransitionTo: aChunk.
	(aChunk canUseTitleFrom: lastVisited) ifFalse: [
		(aChunk isKindOf: lastVisited class) 
			ifTrue: [ self printedLastMethodGroup: lastVisited ].
		self cstMessenger
		print: '\\!!%1 methodsFor: ''%2''!!'
		on: self stream
		withArguments: (
			Array
			with: aChunk methodClassName
			with: (self fixupSource: aChunk category)
		).
	].
	self cstMessenger
		print: '\\%1!!'
		on: self stream
		withArguments: (
			Array 
			with: (self fixupSource: aChunk methodSourceString)
		).
	lastVisited := aChunk.!

printNotice: aChunk

	self printTransitionTo: aChunk.
	self cstMessenger
		print: '\\"\%1\"!!'
		on: self stream
		withArguments: (
			Array with: (self betterDelimitersFor: (self fixupSource: aChunk notice))
		).
	lastVisited := aChunk.!

printPostloadCode: aChunk

	self printTransitionTo: aChunk.
	self cstMessenger
		print: '\\"%1"\%2!!'
		on: self stream
		withArguments: (
			Array 
				with: aChunk groupName
				with: (self fixupSource: aChunk source)
		).
	lastVisited := aChunk.!

printPreloadCode: aChunk

	self printTransitionTo: aChunk.
	self cstMessenger
		print: '\\"%1"\%2!!'
		on: self stream
		withArguments: (
			Array 
				with: aChunk groupName
				with: (self fixupSource: aChunk source)
		).
	lastVisited := aChunk.! !

!SfgChunkWriteStrategy methodsFor: 'printing'!

printTransitionTo: aChunk
	(aChunk isKindOf: lastVisited class) ifFalse: [
		lastVisited isNil ifFalse: [lastVisited printedLastUsing: self].
		aChunk printingFirstUsing: self.
	].! !

!SfgChunkWriteStrategy methodsFor: 'printing-detail'!

printVariable: aChunk

	self printTransitionTo: aChunk.
	self cstMessenger
		print: '\%1 at: #%2 ifAbsent: [%1 at: #%2 put: %3].!!'
		on: self stream
		withArguments: (
			Array
			with: aChunk namespace
			with: aChunk name
			with: aChunk initialValue
		).
	lastVisited := aChunk.! !

!SfgChunkWriteStrategy methodsFor: 'printing'!

properChunkSourceFor: aString
	(aString includes: $!!) ifFalse: [^aString].
	^aString
		copyReplaceAll: '!!'
		with: '!!!!'
!

properSourceFor: aString
	(aString includes: $!!) ifFalse: [^aString].
	^aString
		copyReplaceAll: '!!'
		with: '!!!!'! !

!SfgChunkWriteStrategy methodsFor: 'accessors'!

stream
	^stream!

stream: aStream
	stream := aStream.! !

!SfgChunkWriteStrategy class methodsFor: 'As yet unclassified'!

openFileStreamFor: aString
	"Right now this code only works for VW"
	^aString asFilename writeStream.!

printItem: anItem on: aStream
	^self new 
		printItem: anItem on: aStream!

printItems: newItem on: aStream
	^self new 
		printItems: newItem on: aStream! !

!SfgChunkWriteStrategy class methodsFor: 'Not categorized'!

writeFileFor: anApp
	"	self writeFileFor: CstMessengerSupport.	
		self writeFileFor: PlbFileoutGeneration.	
		self writeFileFor: PlbStateReplicationProtocol.	
		self writeFileFor: PlbStateReplicationProtocolTests.	
		self writeFileFor: PlbOperationModelSupport.	"

	| items aStream |
	items := SfgEnvyReadStrategy read: anApp.
	aStream := self openFileStreamFor: (anApp name asString, '.st').
	self printItems: items on: aStream.
	aStream close.! !

!SfgClassInitialization methodsFor: 'sorting'!

<= chunk

	"Class definitions will group together."
	self generality = chunk generality ifFalse: [^super <= chunk].

	"Sort by class name."
	^self realClassName <= chunk realClassName
!

generality
	^600! !

!SfgClassInitialization methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\%1 %2.!!'
		on: aStream
		withArguments: (
			Array
			with: self realClassName
			with: #initialize
		).
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastClassInitialization: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstClassInitialization: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printClassInitialization: self.! !

!SfgClassInitialization methodsFor: 'accessors'!

realClass
	^realClass!

realClass: aChunk
	realClass := aChunk!

realClassName
	"We don't want 'String class' but simply 'String'."
	| string |
	string :=self realClass name.
	(string includes: $  )
		ifFalse: [^string]
		ifTrue: [^string copyFrom: 1 to: (string indexOf: $ ) - 1].
! !

!SfgClassInitialization methodsFor: 'registering'!

registerWith: aStrategy
	aStrategy addClassInit: self.! !

!SfgClassInitialization class methodsFor: 'Not categorized'!

realClass: aChunk
	^self new realClass: aChunk
! !

!SfgClassInterface methodsFor: 'sorting'!

<= chunk

	| mine chunks |
	"Class definitions will group together."
	self generality = chunk generality ifFalse: [^super <= chunk].

	"Sort by class name if same superclass."
	self realSuperclass == chunk realSuperclass 
		ifTrue: [^self realClass name <= chunk realClass name].

	"Ensure superclass definitions always appear before subclasses."
	(chunk realClass inheritsFrom: self realClass)
		ifTrue: [^true].

	"Now for the slow code."
	mine := self fullClassInheritance.
	chunks := chunk fullClassInheritance.
	1 to: (mine size min: chunks size) do: [:i |
		(mine at: i) == (chunks at: i) 
			ifFalse: [ ^(mine at: i) name <= (chunks at: i) name ].
	].
	^mine size <= chunks size
! !

!SfgClassInterface methodsFor: 'accessors'!

categoryString
	^self chunkGroup longGroupName

!

chunkGroup
	^chunkGroup!

chunkGroup: aGroupChunk
	chunkGroup := aGroupChunk!

classInstVarNameString

	^self realClass class instVarNames
		inject: String new
		into: [:sum :ea | sum, ea, ' ' ].!

classVarNameString

	^self realClass classVarNames
		inject: String new
		into: [:sum :ea | sum, ea, ' ' ].

!

fullClassInheritance

	| last answer |
	answer := OrderedCollection new.
	last := self realClass.
	[last == nil] whileFalse: [
		answer addFirst: last.
		last := last superclass.
	].
	^answer! !

!SfgClassInterface methodsFor: 'sorting'!

generality
	^400! !

!SfgClassInterface methodsFor: 'accessors'!

instVarNameString

	^self realClass instVarNames
		inject: String new
		into: [:sum :ea | sum, ea, ' ' ].

! !

!SfgClassInterface methodsFor: 'testing'!

isDefinition

	^self chunkGroup defines: self realClass
! !

!SfgClassInterface methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\%1 subclass: #%2\  instanceVariableNames: ''%3''\  classVariableNames: ''%4''\  poolDictionaries: ''%5''\  category: ''%6''!!'
		on: aStream
		withArguments: (
			OrderedCollection new
			add: self realSuperclass;
			add: self realClass;
			add: self instVarNameString;
			add: self classVarNameString;
			add: self sharedPoolNameString;
			add: self categoryString;
			yourself
		).
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastClass: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstClass: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printClass: self.! !

!SfgClassInterface methodsFor: 'accessors'!

realClass
	^realClass!

realClass: aClass
	realClass := aClass! !

!SfgClassInterface methodsFor: 'testing'!

realClassIsBytes

	^self realClass isBytes!

realClassIsMetaclass

	(self realClass respondsTo: #isMeta)
		ifTrue: [ ^self realClass isMeta ].
	^self realClass isMetaclass	"VA"
!

realClassIsVariable

	^self realClass isVariable! !

!SfgClassInterface methodsFor: 'iterators'!

realClassMethodsDo: oneArgBlock

	(self realClass class methodsIn: self realGroup) 
		do: [:cm | oneArgBlock value: cm ].
! !

!SfgClassInterface methodsFor: 'accessors'!

realGroup
	^chunkGroup realGroup! !

!SfgClassInterface methodsFor: 'iterators'!

realMethodsDo: oneArgBlock

	(self realClass methodsIn: self realGroup) 
		do: [:cm | oneArgBlock value: cm ].
! !

!SfgClassInterface methodsFor: 'accessors'!

realSuperclass
	^self realClass superclass! !

!SfgClassInterface methodsFor: 'registering'!

registerDefinitionWith: aGenerator

	aGenerator addClass: self.

	self realClassMethodsDo: [:cm | 
		| cmChunk |
		cmChunk := SfgMethodInterface 
			method: cm 
			categories:  (self realClass class categoriesFor: cm selector) 
			group: self chunkGroup.
		cmChunk registerWith: aGenerator.
	].
	self realMethodsDo: [:cm | 
		| cmChunk |
		cmChunk := SfgMethodInterface 
			method: cm 
			categories:  (self realClass categoriesFor: cm selector) 
			group: self chunkGroup.
		cmChunk registerWith: aGenerator.
	].
!

registerExtensionWith: aGenerator

	self realClassMethodsDo: [:cm | 
		| cmChunk |
		cmChunk := SfgMethodInterface 
			method: cm 
			category: self chunkGroup groupName 
			group: self chunkGroup.
		cmChunk registerWith: aGenerator.
	].
	self realMethodsDo: [:cm | 
		| cmChunk |
		cmChunk := SfgMethodInterface 
			method: cm 
			category: self chunkGroup groupName 
			group: self chunkGroup.
		cmChunk registerWith: aGenerator.
	].
!

registerWith: aStrategy
	self isDefinition
		ifTrue: [ self registerDefinitionWith: aStrategy ]
		ifFalse: [ self registerExtensionWith: aStrategy ].
! !

!SfgClassInterface methodsFor: 'accessors'!

sharedPoolNameString

	^self realClass sharedPoolNames
		inject: String new
		into: [:sum :ea | sum, ea, ' ' ].

! !

!SfgClassInterface class methodsFor: 'Not categorized'!

group: aGroupChunk class: aClass

	^self new
		chunkGroup: aGroupChunk;
		realClass: aClass.
! !

!SfgCodeInterface methodsFor: 'sorting'!

<= chunk

	^self generality <= chunk generality
! !

!SfgCodeInterface methodsFor: 'testing'!

canUseTitleFrom: aChunk

	^false
! !

!SfgCodeInterface methodsFor: 'sorting'!

generality

	^self subclassResponsibility
! !

!SfgCodeInterface methodsFor: 'printing'!

printChunkOn: aStream

	super printOn: aStream.
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastCode: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstCode: self.!

printOn: aStream

	self printChunkOn: aStream.
!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printCode: self.! !

!SfgCodeInterface class methodsFor: 'As yet unclassified'!

copyright

	^'Copyright (C) 2000, Paul L. Baumann.  All Rights Reserved.'!

license

^'The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Fileout Generation.

The Initial Developer of the Original Code is Paul Baumann.  
Portions created by Paul Baumann are
Copyright (C) 2000, Paul L. Baumann.  All
Rights Reserved.

Contributor(s):
'.! !

!SfgEnvyReadStrategy methodsFor: 'registering'!

addClass: aChunk

	items add: aChunk.
!

addClassInit: aChunk

	items add: aChunk.
!

addGroup: aChunk

	items add: aChunk.
!

addMethod: aChunk

	items add: aChunk.
!

addNotice: aChunk

	items add: aChunk.
!

addPostloadCode: aChunk

	items add: aChunk.
!

addPreloadCode: aChunk

	items add: aChunk.
!

addVariable: aChunk

	items add: aChunk.
! !

!SfgEnvyReadStrategy methodsFor: 'initialization'!

initialize
	items := Set new: 1000.! !

!SfgEnvyReadStrategy methodsFor: 'accessors'!

items
	^items!

items: aCollection
	items := aCollection.! !

!SfgEnvyReadStrategy methodsFor: 'sorting'!

sortedItems
	^items asSortedCollection asArray
! !

!SfgEnvyReadStrategy class methodsFor: 'As yet unclassified'!

new
	^super new initialize!

read: anApp
	"	self read: PlbStateReplicationProtocol.	"

	| code answer |
	answer := self new.
	code := SfgGroupInterface group: anApp.
	code registerWith: answer.
	^answer items! !

!SfgGroupInterface methodsFor: 'sorting'!

<= chunk

	"Class definitions will group together."
	self generality = chunk generality ifFalse: [^super <= chunk].

	"Nest groups."
	(chunk isSubgroupOf: self) ifTrue: [^true].

	"Sort by group name."
	^self groupName <= chunk groupName
! !

!SfgGroupInterface methodsFor: 'testing'!

defines: aClass

	^self realGroup defined includes: aClass! !

!SfgGroupInterface methodsFor: 'sorting'!

generality
	^200! !

!SfgGroupInterface methodsFor: 'accessors'!

groupGlobalNames

	^(self realGroup class includesSelector: #toBeLoadedGlobalNames)
		ifTrue: [self realGroup toBeLoadedGlobalNames]
		ifFalse: [Array new].!

groupName
	^self realGroup name
!

groupNamespace
	^#Smalltalk
!

groupNotice

	^(self realGroup class includesSelector: #notice)
		ifTrue: [self realGroup notice]
		ifFalse: [nil].!

groupPostloadCode

	| code |
	(self realGroup class includesSelector: #loaded)
		ifFalse: [^nil].		
	code := (self realGroup class >> #loaded) sourceString.
	code := code copyFrom: #loaded size + 1 to: code size.
	code := code trimSeparators.
	^code

!

groupPreloadCode

	| answer |
	answer := self realGroup toBeLoadedCode trimSeparators.
	^answer isEmpty ifTrue: [nil] ifFalse: [answer]
!

groupPrerequisites

	^self realGroup rootApplication prerequisites
!

groupSignature
	^self realGroup signature! !

!SfgGroupInterface methodsFor: 'testing'!

isSubgroupOf: aGroupChunk

	| last |
	last := self realGroup.
	[ last == nil ] whileFalse: [
		last == aGroupChunk realGroup
			ifTrue: [ ^true ].
		last := last parent.
	].
	^false.! !

!SfgGroupInterface methodsFor: 'accessors'!

longGroupName
	self realGroup parent isNil ifTrue: [^self realGroup name].
	^self realGroup parent name asString, '-', self realGroup name.
! !

!SfgGroupInterface methodsFor: 'iterators'!

namespaceDefinitionsDo: twoArgBlock

	self groupGlobalNames collect: [:ea |
		twoArgBlock value: self groupNamespace value: ea.
	].
! !

!SfgGroupInterface methodsFor: 'accessors'!

parentGroupCount
	| last count |
	last := self realGroup.
	count := 0.
	[(last := last parent) isNil] 
		whileFalse: [count := count + 1].
	^count
! !

!SfgGroupInterface methodsFor: 'printing'!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastGroup: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstGroup: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printGroup: self.! !

!SfgGroupInterface methodsFor: 'accessors'!

realGroup
	^realGroup
!

realGroup: anApp
	realGroup := anApp
! !

!SfgGroupInterface methodsFor: 'registering'!

registerWith: aStrategy

	self groupNotice isNil ifFalse: [
		(SfgNotice notice: self groupNotice) 
			registerWith: aStrategy.
	].
	aStrategy addGroup: self.
	self realGroup classes do: [:cl |
		cl name = self groupName ifFalse: [
			(SfgClassInterface group: self class: cl)
				registerWith: aStrategy.
		].
	].
	self realGroup subApplications do: [:sub |
		(self class group: sub)
			registerWith: aStrategy.
	].
	self namespaceDefinitionsDo: [:nsName :varName |
		(SfgNamespaceVariableDefinition name: varName namespace: nsName) 
			registerWith: aStrategy.
	].
	self groupPreloadCode isNil ifFalse: [
		(SfgPreloadCode source: self groupPreloadCode group: self) 
			registerWith: aStrategy.
	].
	self groupPostloadCode isNil ifFalse: [
		(SfgPostloadCode source: self groupPostloadCode group: self) 
			registerWith: aStrategy.
	].

		! !

!SfgGroupInterface class methodsFor: 'Not categorized'!

group: anApp
	^self new realGroup: anApp! !

!SfgMethodInterface methodsFor: 'sorting'!

<= chunk

	"Class definitions will group together."
	self generality = chunk generality ifFalse: [^super <= chunk].
	self chunkGroup == chunk chunkGroup 
		ifFalse: [^self chunkGroup <= chunk chunkGroup].
	self methodClass == chunk methodClass
		ifFalse: [^self methodClass name <= chunk methodClass name ].
	"Sort by selector name."
	^self selector <= chunk selector
! !

!SfgMethodInterface methodsFor: 'testing'!

canUseTitleFrom: aChunk

	(aChunk isKindOf: self class) ifFalse: [^false].
	self methodClass = aChunk methodClass ifFalse: [^false].
	^self category = aChunk category
! !

!SfgMethodInterface methodsFor: 'accessors'!

category
	^category!

category: aString
	category := aString!

chunkGroup
	^chunkGroup!

chunkGroup: aGroupChunk
	chunkGroup := aGroupChunk! !

!SfgMethodInterface methodsFor: 'sorting'!

generality
	^500! !

!SfgMethodInterface methodsFor: 'accessors'!

methodClass
	^self realMethod methodClass! !

!SfgMethodInterface methodsFor: 'testing'!

methodClassIsMetaclass

	(self methodClass respondsTo: #isMeta)
		ifTrue: [ ^self methodClass isMeta ].
	^self methodClass isMetaclass	"VA"
! !

!SfgMethodInterface methodsFor: 'accessors'!

methodClassName
	"Should answer 'String' or 'String class' for metaclass."
	^self methodClass name
!

methodSourceString
	^self realMethod sourceString
! !

!SfgMethodInterface methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\!!%1 methodsFor: ''%2''!!\\%3!!\'
		on: aStream
		withArguments: (
			Array
			with: self methodClassName
			with: self category
			with: (self methodSourceString copyReplaceAll: '!!' with: '!!!!')
		).!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastMethod: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstMethod: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printMethod: self.! !

!SfgMethodInterface methodsFor: 'accessors'!

realMethod
	^realMethod!

realMethod: aCM
	realMethod := aCM! !

!SfgMethodInterface methodsFor: 'registering'!

registerWith: aStrategy

	aStrategy addMethod: self.
	(self selector == #initialize and: [self methodClassIsMetaclass]) ifTrue: [
		(SfgClassInitialization realClass: self methodClass) 
			registerWith: aStrategy.
	].
! !

!SfgMethodInterface methodsFor: 'accessors'!

selector
	^self realMethod selector! !

!SfgMethodInterface class methodsFor: 'As yet unclassified'!

method: aCM categories: cats group: aGroupChunk
	
	| cat |
	cats size = 1 
	ifTrue: [ cat := cats first ]
	ifFalse: [
		| wStream |
		wStream := WriteStream on: String new.
		1 to: cats size do: [:i |
			wStream nextPutAll: (cats at: i).
			i = cats size ifFalse: [ wStream nextPutAll: ' + ' ].
		].
		cat := wStream contents.
	].
	^self method: aCM category: cat group: aGroupChunk!

method: aCM category: cat group: aGroupChunk
	^self new 
		realMethod: aCM; 
		category: cat;
		chunkGroup: aGroupChunk! !

!SfgNamespaceVariableDefinition methodsFor: 'sorting'!

<= chunk

	"Class definitions will group together."
	self generality = chunk generality ifFalse: [^super <= chunk].
	self namespace == chunk namespace 
		ifFalse: [^self namespaceName <= chunk namespaceName].
	^self name <= chunk name
!

generality
	^300! !

!SfgNamespaceVariableDefinition methodsFor: 'accessors'!

initialValue
	^initialValue!

initialValue: anObject
	initialValue := anObject!

name
	^name!

name: aString
	name := aString.!

namespace
	^namespace!

namespace: aString
	namespace := aString.!

namespaceName
	^self namespace name! !

!SfgNamespaceVariableDefinition methodsFor: 'printing'!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastVariable: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstVariable: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printVariable: self.! !

!SfgNamespaceVariableDefinition methodsFor: 'registering'!

registerWith: aStrategy
	aStrategy addVariable: self.! !

!SfgNamespaceVariableDefinition class methodsFor: 'As yet unclassified'!

name: aString
	^self 
		name: aString 
		namespace: #Smalltalk
		initialValue: nil!

name: aString namespace: aNsString
	^self 
		name: aString
		namespace: aNsString
		initialValue: nil
! !

!SfgNamespaceVariableDefinition class methodsFor: 'Not categorized'!

name: aString namespace: aNsString initialValue: anObject
	^self new 
		name: aString;
		namespace: aNsString;
		initialValue: anObject! !

!SfgNotice methodsFor: 'sorting'!

generality
	^100! !

!SfgNotice methodsFor: 'accessors'!

notice
	^noticeString!

notice: aString
	noticeString := aString! !

!SfgNotice methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\\"\%1\"!!'
		on: aStream
		withArguments: (
			Array with: self notice
		).
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastNotice: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstNotice: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printNotice: self.! !

!SfgNotice methodsFor: 'registering'!

registerWith: aStrategy
	aStrategy addNotice: self.! !

!SfgNotice class methodsFor: 'Not categorized'!

notice: aString
	^self new notice: aString
! !

!SfgPostloadCode methodsFor: 'sorting'!

<= chunk
	self generality = chunk generality ifFalse: [^super <= chunk].
	"Order sub-groups first."
	^chunk chunkGroup <= self chunkGroup
! !

!SfgPostloadCode methodsFor: 'accessors'!

chunkGroup
	^chunkGroup!

chunkGroup: aGroupChunk
	chunkGroup := aGroupChunk! !

!SfgPostloadCode methodsFor: 'sorting'!

generality
	^700! !

!SfgPostloadCode methodsFor: 'accessors'!

groupName
	^self chunkGroup groupName! !

!SfgPostloadCode methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\\%1!!'
		on: aStream
		withArguments: (
			Array with: self source
		).
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastPostloadCode: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstPostloadCode: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printPostloadCode: self.! !

!SfgPostloadCode methodsFor: 'registering'!

registerWith: aStrategy
	aStrategy addPostloadCode: self.! !

!SfgPostloadCode methodsFor: 'accessors'!

source
	^sourceString!

source: aString
	sourceString := aString! !

!SfgPostloadCode class methodsFor: 'Not categorized'!

source: aString group: group
	^self new 
		source: aString; 
		chunkGroup: group
! !

!SfgPreloadCode methodsFor: 'sorting'!

<= chunk
	self generality = chunk generality ifFalse: [^super <= chunk].
	"Order sub-groups last."
	^self chunkGroup <= chunk chunkGroup
! !

!SfgPreloadCode methodsFor: 'accessors'!

chunkGroup
	^chunkGroup!

chunkGroup: aGroupChunk
	chunkGroup := aGroupChunk! !

!SfgPreloadCode methodsFor: 'sorting'!

generality
	^250! !

!SfgPreloadCode methodsFor: 'accessors'!

groupName
	^self chunkGroup groupName! !

!SfgPreloadCode methodsFor: 'printing'!

printChunkOn: aStream

	self cstMessenger
		print: '\\%1!!'
		on: aStream
		withArguments: (
			Array with: self source
		).
!

printedLastUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printedLastPreloadCode: self.!

printingFirstUsing: aStrategy
	"A double-dispatch operation."
	aStrategy printFirstPreloadCode: self.!

printStrategy: aStrategy
	"A double-dispatch operation."
	aStrategy printPreloadCode: self.! !

!SfgPreloadCode methodsFor: 'registering'!

registerWith: aStrategy
	aStrategy addPostloadCode: self.! !

!SfgPreloadCode methodsFor: 'accessors'!

source
	^sourceString!

source: aString
	sourceString := aString! !

!SfgPreloadCode class methodsFor: 'Not categorized'!

source: aString group: group
	^self new 
		source: aString; 
		chunkGroup: group
!
"	***** End of file *****	"!