"	***** Smalltalk chunk source generated June 12, 2000 at 5:54:47 pm *****	"!

"	***** Prerequisites *****	
		PlbStateReplicationProtocol 2.1 006
"!

"	***** Included versions *****	"!
"	PlbStateReplicationProtocolTests 2.1 001		"!

"	***** Class declarations *****	"!

SrpMappingSaveRule subclass: #SrtSaveExchangeRule
	instanceVariableNames: 'string actual hash '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

Object subclass: #SrtTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtTest subclass: #SrtSrpTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrpDifficultReplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtBehaviorResolution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtDialectPortability
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtLiteralReplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtMetastateTableReplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtMultipleObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtPortableMappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtReadWriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtStreamEncoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!

SrtSrpTest subclass: #SrtSubstitutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbStateReplicationProtocolTests'!


"	***** Behavior declarations *****	"!

!SrpDifficultReplication methodsFor: 'Not categorized'!

isValidNastyObject1: anObject


	1 to: anObject size do: [:index |
		(anObject at: index) first == anObject 
			ifFalse: [^false].
	].
	^true
! !

!SrpDifficultReplication methodsFor: 'As yet unclassified'!

nastyObject1
	"Warning: nastyObject is really nasty to dialects that don't allow
	 recursive printing. VW will get into an infinite loop trying to
	 get the printString of the nastyObject."

	| nastyObject |
	nastyObject := Array new: 3.
	1 to: 3 do: [:index |
		nastyObject
			at: index
			put: OrderedCollection new.
		(nastyObject at: index) add: nastyObject.
	].
	^nastyObject
!

testNastyObject1Replication

	"	 self new testNastyObject1Replication.	"

	"A bug was reported while replicating an object as described by
	 #nastyObject1. The bug was an infinite loop sending #hash to
	 a recursive object in a Set while loading. The fix was to use
	 an identitySet instead; however not all dialects have an
	 IdentitySet class. Some dialects may fail this test if 
	 #identitySetClass returns a normal Set."

	self 
		run: [self isValidNastyObject1: self nastyObject1] 
		is: true.
	self 
		run: [self isValidNastyObject1: (self replicate: self nastyObject1)] 
		is: true.
	self 
		run: [self isValidNastyObject1: (self replicateBase64: self nastyObject1)] 
		is: true.
	self 
		run: [self isValidNastyObject1: (self replicateMinimal: self nastyObject1)] 
		is: true.
! !

!SrtBehaviorResolution methodsFor: 'As yet unclassified'!

testNameConversions
	"	self new testNameConversions	"
	"Note: ST/X doesn't support #withAllSubclassesDo:."
	Collection withAllSubclasses do: [:aClass |
		| namePath resolved |
		namePath := SrpPortal namespacePathForClass: aClass.
		resolved := SrpPortal behaviorForNamespacePath: namePath.
		resolved == aClass ifFalse: [ self failure ].
	].! !

!SrtDialectPortability methodsFor: 'As yet unclassified'!

testFileReads
	"	self new testFileReads.	"

	"Note: VW VariableBinding currently isn't being remapped.
			   This will produce multiple class doesn't exist warnings."
"	self timedReadFilename: 'vwTestSrpDefaultsComplexObject.srp'.
	self timedReadFilename: 'vwTestRtcDefaultsComplexObject.srp'.
"
	self timedReadFilename: 'vaTestSrpDefaultsComplexObject.srp'.
	self timedReadFilename: 'vaTestRtcDefaultsComplexObject.srp'.!

timedReadFilename: filename
	| ostream t1 obj |
	(SrpPortal stringExistsAsFile: filename) ifFalse: [
		SrpPortal messenger
			comment: 'File ''%1'' didn''t exist for test load.'
			with: filename.
		^nil
	].
	ostream := self newStreamFilename: filename.
	t1 := Time millisecondsToRun: [ obj := ostream next ].
	ostream close.
	SrpPortal messenger 
		comment: 'File ''%1'' loaded in %2ms.'
		with: filename
		with: t1.
	^obj!

timedWriteRead: obj on: ostream filename: filename
	| t1 t2 startPos |
	t1 := Time millisecondsToRun: [ ostream nextPut: obj ].
	ostream reset.
	startPos := ostream position.
	t2 := Time millisecondsToRun: [ ostream next ].
	SrpPortal messenger 
		comment: 'File %1\	save %2ms\	load %3ms\	size %4 bytes.'
		with: filename
		with: t1 with: t2 with: ostream position - startPos.
!

vaTestRtcDefaultsComplexObjectWrite
	"	self new vaTestRtcDefaultsComplexObjectWrite.	"

	| filename ostream obj |
	filename := 'vaTestRtcDefaultsComplexObject.srp'.
	obj := self complexObject.
	ostream := (self newStreamFilename: filename)
		metastateTableName: 'RtcDefaults1';
		yourself.
	self
		timedWriteRead: obj
		on: ostream
		filename: filename.
	ostream close.!

vaTestSrpDefaultsComplexObjectWrite
	"	self new vaTestSrpDefaultsComplexObjectWrite.	"

	| filename ostream obj |
	filename := 'vaTestSrpDefaultsComplexObject.srp'.
	obj := self complexObject.
	ostream := self newStreamFilename: filename.
	self
		timedWriteRead: obj
		on: ostream
		filename: filename.
	ostream close.!

vwTestRtcDefaultsComplexObjectWrite
	"	self new vwTestRtcDefaultsComplexObjectWrite.	"

	| filename ostream obj |
	filename := 'vwTestRtcDefaultsComplexObject.srp'.
	obj := self complexObject.
	ostream := (self newStreamFilename: filename)
		metastateTableName: 'RtcDefaults1';
		yourself.
	self
		timedWriteRead: obj
		on: ostream
		filename: filename.
	ostream close.!

vwTestSrpDefaultsComplexObjectWrite
	"	self new vwTestSrpDefaultsComplexObjectWrite.	"

	| filename ostream obj |
	filename := 'vwTestSrpDefaultsComplexObject.srp'.
	obj := self complexObject.
	ostream := self newStreamFilename: filename.
	self
		timedWriteRead: obj
		on: ostream
		filename: filename.
	ostream close.! !

!SrtLiteralReplication methodsFor: 'As yet unclassified'!

equalityLiterals
	"Literals that should compare = when replicated."

	^(OrderedCollection new)
		add: 'ABC';
		add: 999999999999999;
		add: -999999999999999;
		add: 1.5;
		add: -1.5;
		add: 1 / 3;
		add: -1 / 3;
		add: #(#name #date);
		add: (SrpPortal byteArrayClassWithAll: #(255 65 66 67 0));
		asArray!

identityLiterals
	"Literals that should compare == when replicated."

	^#(true false nil #name $A 7 -7)!

testLiteralDefaultReplications
	"	self new testLiteralDefaultReplications	"

	self equalityLiterals do: [:ea |
		self run: [self replicate: ea] equals: ea.
		self run: [self replicateMinimal: ea] equals: ea.
		self run: [self replicateBase64: ea] equals: ea.
	].
	self identityLiterals do: [:ea |
		self run: [self replicate: ea] is: ea.
		self run: [self replicateMinimal: ea] is: ea.
		self run: [self replicateBase64: ea] is: ea.
	].!

testSingletonCreation
	"Because #srpLoaded also returns the image singleton,
	 implementors of #srpNew that return the image
	 singleton are redundant. Failing this test may not
	 matter so long as replication works properly."

	self run: [True srpNew] is: true.
	self run: [False srpNew] is: false.
	self run: [UndefinedObject srpNew] is: nil.
!

testStringReplications
	"	self new testStringReplications	"

	| stream |
	stream := WriteStream on: String new.
	self run: [self replicate: stream contents] equals: stream contents.
	stream cr.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPut: $A.
	self run: [self replicate: stream contents] equals: stream contents.
	stream cr.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPutAll: 'ABCD'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream cr; nextPutAll: 'EFGH'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream cr; cr; nextPutAll: 'IJKL'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPut: (Character value: 10); cr; nextPutAll: 'MNOP'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPut: (Character value: 13); cr; nextPutAll: 'QRST'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPut: (Character value: 13); nextPut: (Character value: 13); cr; nextPutAll: 'UVW'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream nextPut: (Character value: 10); nextPut: (Character value: 10); cr; nextPutAll: 'XYZ'.
	self run: [self replicate: stream contents] equals: stream contents.
	stream cr; cr; tab; cr; cr.
	self run: [self replicate: stream contents] equals: stream contents.! !

!SrtMetastateTableReplication methodsFor: 'As yet unclassified'!

testSrpDefaultsComplexObjectWriteRead
	"	self new testSrpDefaultsComplexObjectWriteRead	"

	| ostream method t1 t2 bytes |
	method := self complexObject.
	ostream := self newStream.
	t1 := Time millisecondsToRun: [ ostream nextPut: method ].
	ostream reset.
	t2 := Time millisecondsToRun: [ ostream next ].
	bytes := ostream streamContents.
	SrpPortal messenger 
		comment: '%1\	save %2ms\	load %3ms\	size %4 bytes.'
		with: #testSrpDefaultsComplexObjectWriteRead
		with: t1 with: t2 with: bytes size.!

vaTestSwapperComplexObjectWriteRead
	"	self new vaTestSwapperComplexObjectWriteRead.	"

	| method stream bytes t1 t2 |
	method := self complexObject.
	stream := ReadWriteStream on: ByteArray new.
	t1 := Time millisecondsToRun: [
			(Smalltalk at: #ObjectDumper) new
				unload: method intoStream: stream.
	].
	stream reset.
	t2 := Time millisecondsToRun: [
		(Smalltalk at: #ObjectLoader) new
			loadFromStream: stream.
	].
	bytes := stream contents.
	SrpPortal messenger 
		comment: '%1\	save %2ms\	load %3ms\	size %4 bytes.'
		with: #vaTestSwapperComplexObjectWriteRead
		with: t1 with: t2 with: bytes size.!

vwTestBossComplexObjectWriteRead
	"	self new vwTestBossComplexObjectWriteRead	"

	| method stream boss bytes t1 t2 |
	method := self complexObject.
	stream := ReadWriteStream on: ByteArray new.
	boss := (Smalltalk at: #BinaryObjectStorage ifAbsent: [^self]) onNew: stream.
	boss expectCycles: true.
	t1 := Time millisecondsToRun: [
			boss nextPut: method.
	].
	boss reset.
	t2 := Time millisecondsToRun: [
		boss next.
	].
	bytes := stream contents.
	SrpPortal messenger 
		comment: '%1\	save %2ms\	load %3ms\	size %4 bytes.'
		with: #vwTestBossComplexObjectWriteRead
		with: t1 with: t2 with: bytes size.! !

!SrtMultipleObjectTest methodsFor: 'Not categorized'!

testWriteReadMultipleObjects
	"	self new testWriteReadMultipleObjects	"

	| objs |
	objs := (0 to: 99) asArray.
	self run: [
		self newStream
			nextPutAll: objs;
			contents.
	] equals: objs.
	
! !

!SrtMultipleObjectTest methodsFor: 'As yet unclassified'!

testWriteReadMultipleObjectsBase64
	"	self new testWriteReadMultipleObjectsBase64	"

	| objs |
	objs := (0 to: 99) asArray.
	self run: [
		self newStreamBase64
			nextPutAll: objs;
			contents.
	] equals: objs.
	
! !

!SrtPortableMappingTest methodsFor: 'As yet unclassified'!

collectionInstances
	" self runTests	"
	^OrderedCollection new
	"	add: (Bag with: 'you' with: 'me' with: 'others');	
		add: (Set with: 'you' with: 'me' with: 'others');	
		add: (Dictionary new
			at: 'you' put: 'Sam';
			at: 'me' put: 'Paul';
			at: 'others' put: 'World';
			yourself);
		add: (IdentityDictionary new
			at: #'you' put:  'Sam';
			at: #'me' put: 'Paul';
			at: #'others' put: 'World';
			yourself);	"
		add: (50 to: 75);
		add: ((-999 to: 3010 by: 11) asArray);
		add: (SrpPortal byteArrayClassWithAll: (0 to: 255));
		add: (SrpPortal byteArrayClassWithAll: (0 to: 255)) asString;
		add: (self newDoubleByteString);
		yourself.!

newDoubleByteString

	"Couldn't create DBString in VA with (String with: (Character value: 16rFFF).
	 Couldn't create TwoByteString in VW with ((Character value: 16rFFF) asString).
	 Had to rely on my own portable method #asTwoByteString added to VA."

	SrpPortal twoByteStringClass isNil ifTrue: [^String new].
	^(WriteStream on: (SrpPortal stringAsTwoByteString: String new))
		nextPutAll: ((0 to: 16rFFFF by: 50) collect: [:ea | Character value: ea ]);
		contents.!

testCommonCollectionReplications
	"	self new testCommonCollectionReplications	"

	| all |
	(all := self collectionInstances) do: [:ea |
		self run: [self replicate: ea] equals: ea.
	].
	self run: [self replicate: all] equals: all.!

testDateReplications
	"self new testDateReplications	"

	| d |
	d := Date today.
	self run: [ self replicate:d  ] equals: d.
	self run: [ self replicateMinimal:d  ] equals: d
!

testTimeReplications
	"self new testTimeReplications	"

	| t |
	t := Time now.
	self run: [ self replicate:t  ] equals: t.
	self run: [ self replicateMinimal: t ] equals: t! !

!SrtReadWriteTest methodsFor: 'Test running'!

testConsistentWrite

	| obj previous |
	obj := self complexObject.
	previous := nil.
	1 to: 5 do: [:i |
		| current |
		current := SrpObjectStream saveObjectAsBinary: obj.
		previous isNil ifFalse: [
			previous = current ifFalse: [ self failure ].
		].
		previous := current.
	].! !

!SrtSaveExchangeRule methodsFor: 'As yet unclassified'!

asNative
	"Answer an object that is to represent the receiver.
	 Keep in mind that each slot of the receiver may
	 have a loader socket around it. Also be aware that
	 when an object references the receiver, and the receiver
	 also references that object, that the slots for that
	 object may not be fully loaded yet."

	^actual!

object: anObject

	string := anObject printString.
	actual := anObject.
	hash := anObject hash.! !

!SrtSaveExchangeRule class methodsFor: 'As yet unclassified'!

applicableClassNames
	"Answer a collection of all class names whose instances
	 are affected by the receiver. The receiver will be applied
	 to all instances of classes named in the list."

	^#(Date)!

applicationPriority
	"Answer a value that will be used to sequence mapping 
	 rules in case there are multiple rules defined for the same
	 class. Higher values have priority over lower values."

	^1500
!

applyTo: anObject context: context
	"The receiver is given the opportunity to apply mapping
	 rules to anObject. Answer anObject or another object
	 that is to take the place of anObject."

	^self new object: anObject
!

isDefaultRule
	"Answer boolean whether this rule should added to
	 the collection of active rules by default. By default,
	 all mapping rules will be added. You must override
	 this method to answer false if you want to add rules
	 only under certain conditions--which you also specify."

	^false

! !

!SrtSrpTest methodsFor: 'Test running'!

complexObject
	"Answer something big and complex for testing. A good test
	 object would have lots of recursion and references to identical
	 objects. Use the parse nodes produced by the RtcCompiler
	 if that is loaded in the image."

	| aClass |
	aClass := Smalltalk at: #RtcCompiler ifAbsent: [].
	aClass isNil ifFalse: [
		^(aClass class >> #parseSTElementsFromString:) asRtcCompiledMethod.
	].

	"Need a big, portable object here. This is just a start."
	^OrderedCollection 
		with: #(1 abc (4 5 6) ghi)
		with: 2@4
		with: (Association key: 1 value:'one')
		with: (Dictionary new at: #a put: $A;at: #b put: $B;yourself)! !

!SrtSrpTest methodsFor: 'Srp Test Support'!

newStream

 	^SrpObjectStream new
!

newStreamBase64

 	^self newStream text
!

newStreamFilename: filename
	| aStream |
	aStream := SrpPortal stringAsBinaryFileStream: filename.
 	^SrpObjectStream onBinaryStream: aStream  !

newStreamSansMappings

 	^self newStream
		rulesReject: [:mappingRule | true ];
		yourself!

replicate: anObject

 	^self newStream
		nextPut: anObject;
		reset;
		next!

replicateBase64: anObject
	"Replicate anObject, but only after removing
	 all mapping rules. Only minimal mapping rules
	 should be in effect."

 	^self newStreamBase64
		nextPut: anObject;
		reset;
		next!

replicateMinimal: anObject
	"Replicate anObject, but only after removing
	 all mapping rules. Only minimal mapping rules
	 should be in effect."

 	^self newStreamSansMappings
		nextPut: anObject;
		reset;
		next! !

!SrtStreamEncoding methodsFor: 'Not categorized'!

testBase64ConversionTables
	"	 self new testBase64ConversionTables 	"

	| inst |
	inst := SrpBase64 new.
	0 to: 2r111111 do: [:int |
		int = (inst base64ForBase256: (inst base256ForBase64: int))
			ifFalse: [SrpPortal messenger failure: 'Test failed'].
	].! !

!SrtStreamEncoding methodsFor: 'As yet unclassified'!

testBase64DecodeOfMixedData
	"	 self new testBase64DecodeOfMixedData 	"

	| inst stream bytes validBytes |
	validBytes := (SrpBase64 validCharacters, '=') asByteArray.
	bytes := (SrpPortal byteArrayClassWithAll: (0 to: 255)) 
		reject: [:ea | validBytes includes: ea ].
	stream := ReadWriteStream on: ByteArray new.
	inst := SrpBase64 new srpStream: stream.
	bytes do: [:byte |
		inst nextPut: byte.
		stream nextPut: byte.
	].
	inst contents = bytes
		ifFalse: [SrpPortal messenger failure: 'Test failed'].!

testBase64EncodeAndDecodeAllBytes
	"	 self new testBase64EncodeAndDecodeAllBytes 	"

	| inst stream bytes |
	bytes := SrpPortal byteArrayClassWithAll: (0 to: 255).
	stream := ReadWriteStream on: ByteArray new.
	inst := SrpBase64 new srpStream: stream.
	inst nextPutAll: bytes.
	inst contents = bytes
		ifFalse: [SrpPortal messenger failure: 'Test failed'].!

testBase64EncodeAndDecodeValidCharacters
	"	 self new testBase64EncodeAndDecodeValidCharacters 	"

	| inst stream |
	stream := ReadWriteStream on: ByteArray new.
	inst := SrpBase64 new srpStream: stream.
	inst nextPutAll: SrpBase64 validCharacters asByteArray.
	inst contents asString = SrpBase64 validCharacters
		ifFalse: [SrpPortal messenger failure: 'Test failed'].!

testBase64FinishByteGroup
	"	 self new testBase64FinishByteGroup 	"

	| inst stream strings |
	strings := #('ABC' 'ABC' 'AB' 'A' 'ABCD').
	stream := (ReadWriteStream with: 'abcdefghijklmnopqrstuvwxyz' asByteArray)
		reset; yourself.
	inst := SrpBase64 new srpStream: stream.
	strings do: [:ea | inst nextPutAll: (ea asByteArray); srpFinishByteGroupWrite ].
	stream contents asString = 'QUJDQUJDQUI=QQ==QUJDRA==yz'
		ifFalse: [ SrpPortal messenger failure: 'Test failed.' ].
	^inst contents asString.!

testBase64Flush
	"	 self new testBase64Flush 	"

	| inst stream strings |
	strings := #('ABC' 'ABC' 'AB' 'A' 'ABCD').
	stream := (ReadWriteStream with: 'abcdefghijklmnopqrstuvwxyz' asByteArray)
		reset; yourself.
	inst := SrpBase64 new srpStream: stream.
	strings do: [:ea | inst nextPutAll: (ea asByteArray); flush ].
	stream contents asString = 'QUJDQUJDQUJBQUJDRLstuvwxyz'
		ifFalse: [ SrpPortal messenger failure: 'Test failed.' ].
	^inst contents asString.!

testBase64FlushInPlace
	"	 self new testBase64FlushInPlace 	"

	| inst stream strings |
	strings := #('ABC' 'ABC' 'AB' 'A' 'ABCD').
	stream := (ReadWriteStream with: 'abcdefghijklmnopqrstuvwxyz' asByteArray)
		reset; yourself.
	inst := SrpBase64 new srpStream: stream.
	strings do: [:ea | inst nextPutAll: (ea asByteArray); srpFlushInPlace ].
	stream contents asString = 'QUJDQUJDQUJBQUJDRLstuvwxyz'
		ifFalse: [SrpPortal messenger failure: 'Test failed.' ].
	^inst contents asString.!

testBase64FlushInPlacePreservesExistingData
	"	 self new testBase64FlushInPlacePreservesExistingData 	"

	| inst stream strings |
	strings := #('ABC' 'ABC' 'AB' 'A' 'ABCD').
	stream := (ReadWriteStream with: 'abcdefghijklmnopqrstuvwxyz' asByteArray)
		reset; yourself.
	inst := SrpBase64 new srpStream: stream.
	strings do: [:ea | inst nextPutAll: (ea asByteArray); srpFlushInPlace; skip: 1 ].
	stream contents asString = 'QUJDeQUJDjQUKJBpQUJDRPwxyz'
		ifFalse: [SrpPortal messenger failure: 'Test failed' ].!

testWrappedBase64
	"	self new testWrappedBase64.	"

	| stream inst |
	stream := ReadWriteStream on: ByteArray new.
	inst := SrpWrappedBase64 new srpStream: stream.
	inst srpCurrentLineLength = 0
		ifFalse: [SrpPortal messenger failure: 'Test failed'].
	inst nextPut: $A asInteger.
	inst srpCurrentLineLength = 1
		ifFalse: [SrpPortal messenger failure: 'Test failed'].
	inst nextPutAll: 'bcdefg' asByteArray.
	inst srpCurrentLineLength = 7
		ifFalse: [SrpPortal messenger failure: 'Test failed'].
	inst nextPut: 10.
	inst srpCurrentLineLength = 0
		ifFalse: [SrpPortal messenger failure: 'Test failed'].
	inst nextPutAll: 'hijkl' asByteArray.
	inst srpCurrentLineLength = 5
		ifFalse: [SrpPortal messenger failure: 'Test failed'].! !

!SrtSubstitutionTest methodsFor: 'As yet unclassified'!

testSelfReferencingSubstitution
	"	self new testSelfReferencingSubstitution.	"

	"Uses a mapping rule that will exchange a date for
	 an object that refers to the same date. Tests to see
	 that the date is actually saved instead of just a relative
	 reference to the substitute (would loop when loading)."
	
	| origDate loaded |
	origDate := Date today.
	loaded := self newStream
		addMappingRules: (Array with: SrtSaveExchangeRule);
		nextPut: origDate;
		reset;
		next.
	loaded = origDate ifFalse: [ self failure ].

	"Note: For performance reasons, SRP only allows self-referencing 
	 substitutions in which the new substitute has a *local* reference to
	 the original. X replaced with (X asValue) is OK. X replaced with
	 (X asValue asValue) would fail."
! !

!SrtTest methodsFor: 'Reporting'!

aboutToRun
	"Do nothing by default"!

aboutToRun: testSelector
	"Do nothing by default"! !

!SrtTest methodsFor: 'Test running'!

allSelectorsMatching: matchString

	^self class selectors asSortedCollection
		select: [:ea | matchString match: ea ].!

allTestSelectors

	^(self allSelectorsMatching: 'test*'),
	 (self allSelectorsMatching: self class smalltalkTestPrefix, '*').! !

!SrtTest methodsFor: 'Reporting'!

finishedRunning: testSelector forMs: milliseconds
	"Do nothing by default"!

finishedRunningForMs: milliseconds
	"Do nothing by default"! !

!SrtTest methodsFor: 'Test running'!

run: runBlock equals: expected

	| result |
	result := runBlock value.
	result = expected ifFalse: [
		SrpPortal messenger 
			failure: 'Test failed. Expected %1, received %2' 
			with: expected 
			with: result 
	].!

run: runBlock is: expected

	| result |
	result := runBlock value.
	result == expected ifFalse: [
		SrpPortal messenger 
			failure: 'Test failed. Expected %1, received %2' 
			with: expected 
			with: result 
	].!

runTests
	"	self runTests	"

	| totalMs |
	self aboutToRun.
	totalMs := 0.
	self allTestSelectors do: [:selector |
		| ms |
		self aboutToRun: selector.
		ms := Time millisecondsToRun: [self perform: selector].
		self finishedRunning: selector forMs: ms.
		totalMs := totalMs + ms.
	].
	self finishedRunningForMs: totalMs.! !

!SrtTest class methodsFor: 'As yet unclassified'!

runAllTests
	"	self runAllTests	"

	self withAllSubclasses do: [:ea | ea runTests ].
!

runTests
	"	self runTests	"

	self new runTests.!

smalltalkTestPrefix

	| type |
	type := SrpPortal vmTypeName.
	type = #VisualAge ifTrue: [^'vaTest'].
	type = #VisualWorks ifTrue: [^'vwTest'].	
	type = #Dolphin ifTrue: [^'dolTest'].
	type = #'GemStone/S' ifTrue: [^'gssTest'].	
	type = #Squeak ifTrue: [^'sqkTest'].	
	type = #'Smalltalk/X' ifTrue: [^'stxTest'].	
	type = #SmalltalkAgents ifTrue: [^'qksTest'].
	type = #SmalltalkMT ifTrue: [^'smtTest'].
	type = #SmalltalkExpress ifTrue: [^'stvTest'].
	type = #ObjectStudio ifTrue: [^'ostTest'].
	^'Unknown'!
"	***** End of file *****	"!