Object subclass: #OperaORB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaORB class
	instanceVariableNames: ''!

!OperaORB class methodsFor: 'class initialization' stamp: 'MU 2/18/2002 01:30'!
initialize
	"OperaObjectAdapter initialize"
	super initialize.
	OperaPortableUtil initialize.
	
	! !


!OperaORB class methodsFor: 'testing' stamp: 'MU 2/18/2002 01:32'!
isRunning
	^OperaPortableUtil soapIsRunning! !


!OperaORB class methodsFor: 'actions' stamp: 'MU 2/18/2002 01:32'!
init
	OperaSetting initialize.
	OperaObjectAdapter initialize.
	! !

!OperaORB class methodsFor: 'actions' stamp: 'MU 2/23/2002 23:52'!
init: aPort
	OperaSetting  initialize.
	OperaSetting  defaultPort: aPort! !

!OperaORB class methodsFor: 'actions' stamp: 'MU 2/18/2002 01:35'!
run
	"OperaORB run"
	OperaPortableUtil startSoap! !

!OperaORB class methodsFor: 'actions' stamp: 'MU 2/18/2002 01:35'!
shutdown
	"OperaORB shutdown"
	 OperaPortableUtil stopSoap! !


!OperaORB class methodsFor: 'accessing'!
root
	^OperaObjectAdapter root! !


!OperaORB class methodsFor: 'marshal/unmarshal' stamp: 'MU 2/13/2002 00:43'!
objectFromString: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self on: byteStr.
	^oStr next! !

!OperaORB class methodsFor: 'marshal/unmarshal' stamp: 'MU 2/13/2002 00:43'!
stringFromObject: anObject 
	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(self on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents! !


Object subclass: #OperaObjectReference
	instanceVariableNames: 'name host port impl '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

!OperaObjectReference methodsFor: 'comparing'!
= anOperaObjectReference 
	self name = anOperaObjectReference name ifFalse: [^ false].
	self host = anOperaObjectReference host ifFalse: [^ false].
	self port = anOperaObjectReference port ifFalse: [^ false].
	^ true! !

!OperaObjectReference methodsFor: 'comparing'!
hash
	^ self name hash! !


!OperaObjectReference methodsFor: 'converting' stamp: 'MU 2/13/2002 00:40'!
asRemoteObject
	^OperaRemoteObject name: (self name) host: (self host) port: (self port) ! !


!OperaObjectReference methodsFor: 'accessing'!
host
	
	^host! !

!OperaObjectReference methodsFor: 'accessing'!
host: aValue

	host := aValue! !

!OperaObjectReference methodsFor: 'accessing'!
impl
	
	^impl! !

!OperaObjectReference methodsFor: 'accessing'!
impl: aValue

	impl := aValue! !

!OperaObjectReference methodsFor: 'accessing'!
name

	^name! !

!OperaObjectReference methodsFor: 'accessing'!
name: aValue

	name := aValue! !

!OperaObjectReference methodsFor: 'accessing'!
port
	
	^port! !

!OperaObjectReference methodsFor: 'accessing'!
port: aValue

	port := aValue! !


!OperaObjectReference methodsFor: 'object from disk'!
readDataFrom: aDataStream size: varsOnDisk 
	| cntInstVars |
	cntInstVars := varsOnDisk.
	"OK if fewer than now"
	aDataStream beginReference: self.
	1 to: cntInstVars do: [:i | self instVarAt: i put: aDataStream next]! !

!OperaObjectReference methodsFor: 'object from disk'!
storeDataOn: aDataStream 
	| cntInstVars |
	cntInstVars := self class instSize - 1.
	"remove impl"
	aDataStream beginInstance: self class size: cntInstVars.
	1 to: cntInstVars do: [:i | aDataStream nextPut: (self instVarAt: i)]! !


!OperaObjectReference methodsFor: 'initialize-release' stamp: 'MU 2/18/2002 01:27'!
initialize
	host := OperaPortableUtil localAddress.
	port := OperaSetting defaultPort.! !

!OperaObjectReference methodsFor: 'initialize-release' stamp: 'MU 1/22/2002 11:21'!
release
	self releaseFrom: OperaORB root! !

!OperaObjectReference methodsFor: 'initialize-release' stamp: 'MU 1/22/2002 11:20'!
releaseFrom: anObjectAdapter 
	anObjectAdapter removeKey: self name ifAbsent: [].
	name := host := port := impl := nil.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaObjectReference class
	instanceVariableNames: ''!

!OperaObjectReference class methodsFor: 'comparing'!
hasInstance: anObject
	"performance conscious comparison"
	^anObject class name == self name! !


!OperaObjectReference class methodsFor: 'instance creation'!
new
	^super new initialize! !

!OperaObjectReference class methodsFor: 'instance creation'!
on: anObject
	^self new impl: anObject! !


Object subclass: #OperaOidGenerator
	instanceVariableNames: 'highValue lowValue highValueCounter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

!OperaOidGenerator methodsFor: 'accessing'!
highValue

	highValue isNil ifTrue:[ highValue := self privNextValue. ].

	^highValue! !

!OperaOidGenerator methodsFor: 'accessing'!
highValue: aValue

	highValue := aValue! !

!OperaOidGenerator methodsFor: 'accessing'!
highValueCounter
	^highValueCounter! !

!OperaOidGenerator methodsFor: 'accessing'!
highValueCounter: aValue

	highValueCounter := aValue! !

!OperaOidGenerator methodsFor: 'accessing'!
lowValue

	lowValue isNil ifTrue:[ lowValue := self privNextValue. ].

	^lowValue! !

!OperaOidGenerator methodsFor: 'accessing'!
lowValue: aValue

	lowValue := aValue! !


!OperaOidGenerator methodsFor: 'initialize-release'!
initialize
	highValueCounter := 0.! !


!OperaOidGenerator methodsFor: 'actions'!
nextValue
	^(self nextHighValue , self nextLowValue)! !


!OperaOidGenerator methodsFor: 'private'!
nextHighValue
	self highValueCounter: self highValueCounter + 1.
	self highValueCounter > 9999
		ifTrue: 
			[self highValueCounter: 0.
			self highValue: self privNextValue].
	^ self highValue.! !

!OperaOidGenerator methodsFor: 'private'!
nextLowValue
	self lowValue: self privNextValue.
	^ self lowValue.! !

!OperaOidGenerator methodsFor: 'private'!
privNextValue
	| sz str |
	sz := 6.
	str := String new: sz.
	1 to: sz do:[ :idx |
	str at: idx put: 15 atRandom asHexDigit]. 
	^str
	
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaOidGenerator class
	instanceVariableNames: ''!

!OperaOidGenerator class methodsFor: 'instance creation'!
new
	^super new initialize! !


Object subclass: #OperaPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaPortableUtil class
	instanceVariableNames: 'service localAddress localHostname defaultHost defaultEncoding defaultTransport '!

!OperaPortableUtil class methodsFor: 'class initialization' stamp: 'MU 4/1/2002 23:40'!
initialize
	"OperaPortableUtil initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	
	! !

!OperaPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/31/2002 19:19'!
obsolete
	"OperaPortableUtil obsolete"

	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.! !


!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/23/2002 23:59'!
defaultEncoding
	"Assuming SoapOpera Squeak"
	defaultEncoding isNil ifTrue: [defaultEncoding := #soapSqEncoding].
	^defaultEncoding! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/24/2002 00:02'!
defaultEncoding: aSymbol
	"Assuming SoapOpera Squeak"
	defaultEncoding := aSymbol! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/24/2002 01:41'!
defaultHost
	defaultHost isNil ifTrue: [defaultHost := 'localhost'].
	^defaultHost! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/24/2002 01:41'!
defaultHost: aString
	defaultHost := aString! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/18/2002 00:49'!
defaultPort
	"Assuming SoapOpera Squeak"
	^SoapSetting defaultPort! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/23/2002 23:53'!
defaultPort: anInteger
	"Assuming SoapOpera Squeak"
	SoapSetting defaultPort: anInteger! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 9/11/2002 23:21'!
defaultTransport
	"Assuming SoapOpera Squeak"
	^SoapSetting defaultTransport! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 9/11/2002 23:21'!
defaultTransport: aSymbol
	"Assuming SoapOpera Squeak (#http #sqtp)"
	SoapSetting defaultTransport: aSymbol! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 4/18/2003 17:20'!
installRootOOA
	"OperaPortableUtil installRootOOA"
	"TODO: Supports multi SOAP implementaions (Spray or VWSOAP)"
	"Assuming SoapOpera Squeak"
	| rootOOA |
	service notNil
		ifTrue: [self uninstallRootOOA].
	SoapServerSetup restartAt: self defaultTransport port: self defaultPort.
	rootOOA := OperaORB root.
	service := SoapService implementor: rootOOA selector: rootOOA class dispatchSelector.
	service targetObjectURI: rootOOA class serviceTargetObjectURI.
	service signature: rootOOA class dispatchSoapSignature.
	SoapServiceHandler default add: service! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/18/2002 01:31'!
soapIsRunning
	"Assuming SoapOpera Squeak"
	^SoapHttpSetup service isRunning! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 9/11/2002 23:41'!
soapSend: anOperaRemoteMessage host: host port: port transport: transportSymbol 
	"Assuming SoapOpera Squeak"
	| call resp signature |
	call := (SoapCallEntry tcpHost: host port: port) newCall.
	call transport: transportSymbol.
	call targetObjectURI: OperaObjectAdapter serviceTargetObjectURI.
	call encoding: self defaultEncoding.
	signature := OperaObjectAdapter dispatchSoapSignature.
	call methodName: signature name.
	call
		addParameter: (SoapVariable name: signature paramNames first value: anOperaRemoteMessage).
	resp := call invoke.
	^ resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/18/2002 01:34'!
startSoap
	SoapHttpSetup stop.
	SoapHttpSetup start! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/18/2002 01:34'!
stopSoap
	SoapHttpSetup stop! !

!OperaPortableUtil class methodsFor: 'adapter for Soap' stamp: 'MU 2/17/2002 15:37'!
uninstallRootOOA
	"OperaPortableUtil uninstallRootOOA"
	SoapServiceHandler default remove: service.
	service := nil! !


!OperaPortableUtil class methodsFor: 'adapter for Network' stamp: 'MU 2/18/2002 01:05'!
isLocal: host port: port 
	"Squeak specific"
	^ port = self defaultPort
		and: [((host = 'localhost'
						or: [host = '127.0.0.1'])
					or: [host = self localAddress])
				or: [host = self localHostname]]! !

!OperaPortableUtil class methodsFor: 'adapter for Network' stamp: 'MU 2/18/2002 00:59'!
localAddress
	"Squeak specific"
	localAddress isNil ifTrue: [localAddress := NetNameResolver localAddressString].
	^localAddress! !

!OperaPortableUtil class methodsFor: 'adapter for Network' stamp: 'MU 2/18/2002 01:17'!
localHostname
	"Squeak specific"
	localHostname isNil
		ifTrue: [[localHostname := NetNameResolver nameForAddress: NetNameResolver localHostAddress timeout: 30]
				on: Error
				do: [:ex | 
					localHostname := 'localhost'.
					ex return]].
	^ localHostname! !


!OperaPortableUtil class methodsFor: 'adapter for Collection' stamp: 'MU 2/17/2002 16:03'!
iterate: aCollection keysAndValuesDo: aBlock
	"Squeak withIndexDo: is weird"
	^aCollection keysAndValuesDo: aBlock! !


!OperaPortableUtil class methodsFor: 'adapter for System Initialization' stamp: 'MU 3/31/2002 19:24'!
startUp

	service := localAddress := localHostname := nil.
	self installRootOOA.
! !


Object subclass: #OperaRemoteMessage
	instanceVariableNames: 'receiverName selector arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

!OperaRemoteMessage methodsFor: 'accessing' stamp: 'MU 2/17/2002 15:48'!
arguments

	^arguments! !

!OperaRemoteMessage methodsFor: 'accessing' stamp: 'MU 2/17/2002 15:48'!
arguments: aValue

	arguments := aValue! !

!OperaRemoteMessage methodsFor: 'accessing'!
receiverName
	^receiverName! !

!OperaRemoteMessage methodsFor: 'accessing'!
receiverName: anObjectNameSymbol
	receiverName := anObjectNameSymbol! !

!OperaRemoteMessage methodsFor: 'accessing' stamp: 'MU 2/17/2002 16:14'!
selector

	^selector! !

!OperaRemoteMessage methodsFor: 'accessing' stamp: 'MU 2/17/2002 16:14'!
selector: aValue

	selector := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaRemoteMessage class
	instanceVariableNames: ''!

!OperaRemoteMessage class methodsFor: 'instance creation'!
receiverName: anObject selector: aSymbol
	^ self receiverName: anObject selector: aSymbol arguments: #()! !

!OperaRemoteMessage class methodsFor: 'instance creation'!
receiverName: anObject selector: aSymbol argument: aParameter
	^ self receiverName: anObject selector: aSymbol arguments: (Array with: aParameter)! !

!OperaRemoteMessage class methodsFor: 'instance creation'!
receiverName: anObject selector: aSymbol arguments: anArray
	^ self new
		receiverName: anObject;
		selector: aSymbol;
		arguments: anArray! !


ProtoObject subclass: #OperaRemoteObject
	instanceVariableNames: 'name host port '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

!OperaRemoteObject methodsFor: 'special'!
= anOperaObjectReference 
	self oprName = anOperaObjectReference oprName ifFalse: [^ false].
	self oprHost = anOperaObjectReference oprHost ifFalse: [^ false].
	self oprPort = anOperaObjectReference oprPort ifFalse: [^ false].
	^ true! !

!OperaRemoteObject methodsFor: 'special'!
halt
	"useful for debug"

	Halt signal! !

!OperaRemoteObject methodsFor: 'special'!
hash
	^ self oprPrintString hash! !

!OperaRemoteObject methodsFor: 'special'!
inspect
	"useful for debug"
	| dic |
	dic := IdentityDictionary new.
	dic at: #ClassName put: #RemoteObject.
	dic at: #name put: self oprName.
	dic at: #host put: self oprHost.
	dic at: #port put: self oprPort.
	Inspector openOn:  dic withEvalPane: true withLabel: ('a RemoteObject: ', (self oprName)) asSymbol! !

!OperaRemoteObject methodsFor: 'special'!
isRemote
	^true! !

!OperaRemoteObject methodsFor: 'special'!
oprEqueals: anOperaObjectReference 
	
	^self doesNotUnderstand: (Message selector: #= argument: anOperaObjectReference )! !

!OperaRemoteObject methodsFor: 'special'!
oprPrintString
	| aStream |
	"useful for debug"
	aStream := (String new: 64) writeStream.
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort printString.
	^aStream contents
	! !

!OperaRemoteObject methodsFor: 'special'!
printOn: aStream
	"useful for debug"
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort printString.
	! !

!OperaRemoteObject methodsFor: 'special'!
printString
	| stream |
	stream := WriteStream on: String new.
	self printOn: stream.
	^ stream contents! !

!OperaRemoteObject methodsFor: 'special'!
yourself
	"for optimization"

	^self! !


!OperaRemoteObject methodsFor: 'system callback' stamp: 'MU 2/24/2002 01:33'!
doesNotUnderstand: aMessage 
	| remoteMsg | 
	remoteMsg := OperaRemoteMessage
				receiverName: self oprName
				selector: aMessage selector
				arguments: aMessage arguments.
	self oprShowLog
		ifTrue: [Transcript cr; show: '++> ' , remoteMsg receiverName.
			Transcript space; show: remoteMsg selector.
			Transcript space; show: remoteMsg arguments].
	^ OperaConnector default
		send: remoteMsg
		to: self oprHost
		port: self oprPort! !


!OperaRemoteObject methodsFor: 'accessing' stamp: 'MU 7/28/2002 00:16'!
oprHost
	host isNil ifTrue:[host := OperaSetting defaultHost].
	^host! !

!OperaRemoteObject methodsFor: 'accessing'!
oprHost: aValue

	host := aValue! !

!OperaRemoteObject methodsFor: 'accessing'!
oprName
	name isNil ifTrue:[name := 'server'].
	^name! !

!OperaRemoteObject methodsFor: 'accessing'!
oprName: aValue

	name := aValue! !

!OperaRemoteObject methodsFor: 'accessing' stamp: 'MU 2/18/2002 01:16'!
oprPort
	port isNil ifTrue:[port := OperaSetting defaultPort].
	^port	! !

!OperaRemoteObject methodsFor: 'accessing'!
oprPort: aValue

	port := aValue! !

!OperaRemoteObject methodsFor: 'accessing' stamp: 'MU 2/24/2002 01:33'!
oprShowLog
	^self class showLog! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaRemoteObject class
	instanceVariableNames: 'showLog '!

!OperaRemoteObject class methodsFor: 'instance creation'!
name: aSymbol host: aHost 
	^self name: aSymbol host: aHost port: nil! !

!OperaRemoteObject class methodsFor: 'instance creation' stamp: 'MU 2/13/2002 00:39'!
name: aSymbol host: aHost port: aPort 
	| inst |
	inst := self new.
	inst oprName: aSymbol.
	inst oprHost: aHost.
	inst oprPort: aPort.
	^inst! !

!OperaRemoteObject class methodsFor: 'instance creation'!
named: aSymbol
	^self name: aSymbol host: nil! !


!OperaRemoteObject class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:32'!
showLog
	showLog isNil ifTrue: [showLog := false].
	^showLog! !

!OperaRemoteObject class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:33'!
showLog: aBoolean
	showLog := aBoolean! !


Object subclass: #OperaSetting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-Base'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OperaSetting class
	instanceVariableNames: ''!

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/23/2002 23:54'!
defaultEncoding
	^OperaPortableUtil defaultEncoding! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 00:01'!
defaultEncoding: aSymbol
	OperaPortableUtil defaultEncoding: aSymbol! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:38'!
defaultHost
	^OperaPortableUtil defaultHost! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:38'!
defaultHost: aString
	OperaPortableUtil defaultHost: aString! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/23/2002 23:51'!
defaultPort
	^OperaPortableUtil defaultPort! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/23/2002 23:52'!
defaultPort: anInteger
	OperaPortableUtil defaultPort: anInteger! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 9/11/2002 23:29'!
defaultTransport
	^OperaPortableUtil defaultTransport! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 9/11/2002 23:30'!
defaultTransport: aSymbol
	OperaPortableUtil defaultTransport: aSymbol! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:35'!
showClientLog
	^OperaRemoteObject showLog! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 01:35'!
showClientLog: aBoolean
	OperaRemoteObject showLog: aBoolean! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 00:17'!
useColocation
	^OperaConnector useColocation! !

!OperaSetting class methodsFor: 'setting' stamp: 'MU 2/24/2002 00:17'!
useColocation: aBoolean
	OperaConnector useColocation: aBoolean! !

OperaORB initialize!
OperaPortableUtil initialize!