Object subclass: #SixxXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxXmlParserAdapter class
	instanceVariableNames: ''!

!SixxXmlParserAdapter class methodsFor: 'actions' stamp: 'kuri-t 5/16/2002 14:29'!
parseXml: xmlStringOrStream
	self subclassResponsibility! !


!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
attributeAt: attributeName from: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
elementsFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
isTextFrom: sixxElement
	^ sixxElement isText! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 19:23'!
nameFrom: sixxElement
	self subclassResponsibility! !


SixxXmlParserAdapter subclass: #SixxVwXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxVwXmlParserAdapter class
	instanceVariableNames: ''!

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:48'!
attributeAt: attributeName from: sixxElement
	| attr |
	attr := sixxElement attributes
				detect: [:each | each key type = attributeName]
				ifNone: [^ nil].
	^ attr value! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement characterData! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:37'!
elementsFrom: sixxElement 
	^sixxElement elements select: [:each | each isText not]
! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:51'!
nameFrom: sixxElement 
	^ sixxElement tag type! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream parser |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	parser := VWXMLXMLParser on: stream.
	parser validate: false.
	^ parser scanDocument root! !


SixxXmlParserAdapter subclass: #SixxYaxoXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxYaxoXmlParserAdapter class
	instanceVariableNames: ''!

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:44'!
attributeAt: attributeName from: sixxElement
	^ sixxElement attributeAt: attributeName! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement contentString! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
elementsFrom: sixxElement 
	^sixxElement elements
		! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:53'!
nameFrom: sixxElement
	^ sixxElement name! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	^ (XMLDOMParser parseDocumentFrom: stream) topElement! !
