Object subclass: #SoapElement
	instanceVariableNames: 'attributesHolder subElements prefixName localName name value parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapElement commentStamp: '<historical>' prior: 0!
An abstract class for SOAP element.


---
mu 5/21/2001 22:24!


!SoapElement methodsFor: 'initialize-release' stamp: 'mu 1/16/2002 01:36'!
initialize
	attributesHolder := SoapAttributesHolder new.
	
	! !


!SoapElement methodsFor: 'actions' stamp: 'mu 5/5/2001 01:47'!
addSubElement: anXmlElement
	"anXmlElement mustUnderstand:
		#printXmlOn:aStream indent: anInteger
		#parent: anXmlElement"
	anXmlElement parent: self.
	^self subElements add: anXmlElement.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/27/2001 00:10'!
declareDefaultNamespace
	self declareNamespace: SoapConstants soapEnvPrefix  uri: SoapConstants soapEnvURI.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/22/2001 01:49'!
declareEncodingIn: nameSpacePrefix  uri: uriString
	self putAttributeNamed: nameSpacePrefix, ':', SoapConstants encodingStyle value: uriString.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/15/2001 01:24'!
declareNamespace: prefix uri: uri
	self attributesHolder declareNamespace: prefix uri: uri! !

!SoapElement methodsFor: 'actions' stamp: 'mu 12/31/2001 01:50'!
declareSoapEncEncoding
	self declareEncodingIn: SoapConstants soapEnvPrefix uri: SoapConstants soapEncURI.! !

!SoapElement methodsFor: 'actions' stamp: 'mu 12/31/2001 01:51'!
declareSoapEncNamespace
	self declareNamespace: SoapConstants soapEncPrefix  uri: SoapConstants soapEncURI.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 12/31/2001 01:52'!
declareTypicalNamespaces
	self declareSoapEncNamespace.
	self declareXsdNamespace.
	self declareXsiNamespace! !

!SoapElement methodsFor: 'actions' stamp: 'mu 12/31/2001 01:39'!
declareXsdNamespace
	self declareNamespace: SoapConstants xsdPrefix  uri: SoapConstants xsdURI.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 12/31/2001 01:39'!
declareXsiNamespace
	self declareNamespace: SoapConstants xsiPrefix  uri: SoapConstants xsiURI.
	! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/15/2001 01:25'!
declaredNamespacePrefixes
	^self attributesHolder declaredNamespacePrefixes! !

!SoapElement methodsFor: 'actions' stamp: 'mu 8/20/2001 00:58'!
encodingStyleURIs
	"ToDo: take a more serious approach...Namespace conscious"
	| encs |
	encs := self attributesHolder encodingStyle.
	self parent notNil
		ifTrue: [| parentEncodeingURIs myURIs | 
			parentEncodeingURIs := self parent encodingStyleURIs.
			myURIs := SoPortableUtil substringsFrom: encs.
			^ (parentEncodeingURIs ~= myURIs and: [myURIs notEmpty])
				ifTrue: [myURIs]
				ifFalse: [parentEncodeingURIs]].
	^ SoPortableUtil substringsFrom: encs! !

!SoapElement methodsFor: 'actions' stamp: 'MU 10/29/2000 00:59'!
evaluate
	"default do nothing"! !

!SoapElement methodsFor: 'actions' stamp: 'mu 1/14/2002 02:09'!
findSubElementLocalNamed: anElemName
	^self subElements detect: [:each | each localName = anElemName] ifNone:[]! !

!SoapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 18:49'!
findSubElementNamed: anElemName
	^self subElements detect: [:each | each name = anElemName] ifNone:[]! !

!SoapElement methodsFor: 'actions' stamp: 'mu 1/14/2002 02:09'!
findSubElementsLocalNamed: anElemName
	^self subElements select: [:each | each localName = anElemName]! !

!SoapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 18:43'!
findSubElementsNamed: anElemName
	^self subElements select: [:each | each name = anElemName]! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/15/2001 01:25'!
getAttributeNamed: aNameString
	^self attributesHolder getAttributeNamed: aNameString! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/15/2001 01:26'!
putAttribute: aNameValueArray
	^self attributesHolder putAttribute: aNameValueArray! !

!SoapElement methodsFor: 'actions' stamp: 'mu 4/15/2001 01:26'!
putAttributeNamed: attribName value: attribValue
	^self attributesHolder putAttributeNamed: attribName value: attribValue! !

!SoapElement methodsFor: 'actions' stamp: 'MU 4/27/2002 00:26'!
undeclareNamespaces
	self attributesHolder undeclareNamespaces! !


!SoapElement methodsFor: 'accessing' stamp: 'mu 8/12/2001 20:20'!
attributesHolder

	^attributesHolder! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 8/12/2001 20:20'!
attributesHolder: aValue

	attributesHolder := aValue! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/14/2002 01:49'!
localName

	^localName! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/14/2002 02:07'!
localName: aString
	name := nil.
	localName := aString! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/16/2002 01:39'!
name
	name isNil
		ifTrue: [prefixName := SoapConstants soapEnvPrefix.
			localName := self class localName.
			name := prefixName , ':' , localName].
	^ name! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/14/2002 02:16'!
name: aString
	
	name := aString! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 4/22/2001 02:42'!
parent
	^parent! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 4/22/2001 02:42'!
parent: aSoapElement
	parent := aSoapElement! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/14/2002 01:48'!
prefixName

	^prefixName! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 1/14/2002 02:07'!
prefixName: aString
	name := nil.
	prefixName := aString! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 4/22/2001 02:15'!
subElements
	subElements isNil ifTrue: [subElements := OrderedCollection new].
	^subElements! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 8/12/2001 20:20'!
subElements: aValue

	subElements := aValue! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 5/3/2001 02:33'!
value
	^value! !

!SoapElement methodsFor: 'accessing' stamp: 'mu 5/3/2001 02:33'!
value: aString
	value := aString! !


!SoapElement methodsFor: 'testing' stamp: 'mu 1/14/2002 02:44'!
isBody
	^false! !

!SoapElement methodsFor: 'testing' stamp: 'mu 1/14/2002 02:44'!
isEnvelope
	^false! !

!SoapElement methodsFor: 'testing' stamp: 'mu 1/14/2002 02:44'!
isFault
	^false! !

!SoapElement methodsFor: 'testing' stamp: 'mu 1/14/2002 02:44'!
isFaultDetail
	^false! !

!SoapElement methodsFor: 'testing' stamp: 'mu 1/14/2002 02:44'!
isHeader
	^false! !


!SoapElement methodsFor: 'private' stamp: 'mu 5/3/2001 01:45'!
writeName: aCharacterArray on: aStream 
	"ToDo: check illegal characters"
	^ aStream nextPutAll: aCharacterArray! !

!SoapElement methodsFor: 'private' stamp: 'mu 4/15/2001 01:40'!
writeValue: aCharacterArray on: aStream 
	^SoXmlUtil writeXmlText: aCharacterArray on: aStream! !

!SoapElement methodsFor: 'private' stamp: 'mu 5/3/2001 01:45'!
writeValue: aCharacterArray on: aStream betweenTag: aTagString
	"ToDo: check illegal characters"
	aStream nextPutAll: ('<', aTagString, '>').
	SoXmlUtil writeXmlText: aCharacterArray on: aStream.
	aStream nextPutAll: ('</', aTagString, '>').! !


!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/15/2001 01:44'!
printXmlContentsOn: aStream indent: level 
	aStream cr.
	self privPrintChildrenOn: aStream indent: level + 1.
	level timesRepeat: [aStream space].! !

!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/15/2001 01:42'!
printXmlFooterOn: aStream 
	aStream nextPut: $<.
	aStream nextPut: $/.
	self writeName: self name on: aStream.
	aStream nextPut: $>! !

!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/15/2001 01:38'!
printXmlHeaderOn: aStream 
	aStream nextPut: $<.
	self writeName: self name on: aStream.
	self privPrintAttribsOn: aStream.
	aStream nextPut: $>! !

!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/15/2001 01:36'!
printXmlOn: aStream indent: level 
	level
		timesRepeat: [aStream space].
	self printXmlHeaderOn: aStream.
	self printXmlContentsOn: aStream indent: level.
	self printXmlFooterOn: aStream.
	aStream cr! !

!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/15/2001 01:46'!
privPrintAttribsOn: aStream
	self attributesHolder printXmlOn: aStream! !

!SoapElement methodsFor: 'private-printing' stamp: 'mu 4/22/2001 02:16'!
privPrintChildrenOn: aStream indent: level
	"$override$"
	subElements isNil ifFalse: [
		self subElements do:[:each | each  printXmlOn: aStream indent: level].
	]! !


!SoapElement methodsFor: 'printing' stamp: 'mu 4/15/2001 01:35'!
printOn: aStream
	"super printOn: aStream" "for Debug"
	self printXmlOn: aStream! !

!SoapElement methodsFor: 'printing' stamp: 'mu 4/15/2001 01:35'!
printXmlOn: stream
	self printXmlOn: stream indent: 0! !

!SoapElement methodsFor: 'printing' stamp: 'mu 7/16/2001 23:57'!
printXmlString
	| stream |
	stream := WriteStream on: (String new: 1024).
	self printOn: stream.
	^stream contents.! !


!SoapElement methodsFor: 'factory' stamp: 'MU 11/7/2000 11:44'!
parser
	
	^self class parser! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapElement class
	instanceVariableNames: ''!

!SoapElement class methodsFor: 'instance creation' stamp: 'mu 1/14/2002 02:27'!
fromXmlElement: anXmlWrapElement 
	"Create a new SoapElement that wraps the passed XML element 
	or one of its children"
	| inst |
	inst := self named: anXmlWrapElement name.
	self addAttributesOf: anXmlWrapElement to: inst.
	self addSubElementsOf: anXmlWrapElement to: inst.
	^ inst! !

!SoapElement class methodsFor: 'instance creation' stamp: 'mu 1/14/2002 02:38'!
named: anElementName 
	| index readStream prefixName localName |
	index := anElementName indexOf: $:.
	index = 0
		ifTrue: [SoapNoNamespacePrefix signal: 'Namespace prefix must be provided!!']
		ifFalse: [readStream := anElementName readStream.
			prefixName := readStream next: index - 1.
			readStream skip: 1.
			localName := readStream next: anElementName size - index].
	(localName isEmpty
			or: [localName ~= self localName])
		ifTrue: [SoapWrongTagName signal: '"' , localName , '"' , ' must be "' , self localName , '"'].
	^ self new prefixName: prefixName;
		 localName: localName;
		 name: anElementName! !

!SoapElement class methodsFor: 'instance creation' stamp: 'mu 4/15/2001 01:23'!
new
	^super new initialize! !


!SoapElement class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:04'!
localName
	^self name copyReplaceAll: 'Soap' with: ''! !


!SoapElement class methodsFor: 'private' stamp: 'mu 8/12/2001 21:22'!
addAttributesOf: anXmlWrapElement to: aSoapElement
	anXmlWrapElement attributesDictionary
		keysAndValuesDo: [:k :v | aSoapElement putAttributeNamed: k value: v].! !

!SoapElement class methodsFor: 'private' stamp: 'mu 8/12/2001 21:22'!
addSubElementsOf: anXmlWrapElement to: aSoapElement
	anXmlWrapElement children
		do: [:each | aSoapElement addSubElement: each].! !


SoapElement subclass: #SoapBody
	instanceVariableNames: 'fault bodyEntries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapBody commentStamp: '<historical>' prior: 0!
SOAP Body element.


---
mu 5/21/2001 22:24!


!SoapBody methodsFor: 'actions' stamp: 'mu 5/5/2001 01:47'!
addBodyEntry: anXmlElement
	"anXmlElement mustUnderstand:
		#printXmlOn:aStream
		#parent: anXmlElement"
	anXmlElement parent: self.
	^self bodyEntries add: anXmlElement.! !

!SoapBody methodsFor: 'actions' stamp: 'mu 10/27/2001 21:04'!
addFault
	| fa |
	fa := SoapFault new.
	fa parent: self.
	self fault: fa.
	^fa! !

!SoapBody methodsFor: 'actions' stamp: 'mu 10/13/2001 21:04'!
clearBodyEntries
	self bodyEntries
		do: [:each | each parent: nil].
	self bodyEntries: nil! !

!SoapBody methodsFor: 'actions' stamp: 'mu 9/18/2001 18:43'!
findBodyEntriesNamed: anElemName
	^self bodyEntries select: [:each | each name = anElemName]! !

!SoapBody methodsFor: 'actions' stamp: 'mu 8/20/2001 00:27'!
findBodyEntryNamed: anElemName
	^self bodyEntries detect: [:each | each name = anElemName] ifNone:[]! !

!SoapBody methodsFor: 'actions' stamp: 'mu 4/22/2001 02:47'!
isMustUnderstandEnabled
	self parent isNil
		ifTrue: [^ true].
	^ self parent hasHeader
		ifTrue: [self parent header isMustUnderstandEnabled]
		ifFalse: [true]! !


!SoapBody methodsFor: 'testing' stamp: 'MU 11/7/2000 18:41'!
hasFault
	^self fault notNil! !

!SoapBody methodsFor: 'testing' stamp: 'mu 1/14/2002 02:45'!
isBody
	^false! !


!SoapBody methodsFor: 'elements' stamp: 'mu 5/5/2001 01:29'!
bodyEntries
	bodyEntries isNil ifTrue: [bodyEntries := OrderedCollection new].
	^bodyEntries! !

!SoapBody methodsFor: 'elements' stamp: 'mu 5/5/2001 01:26'!
bodyEntries: aCollectionOfXmlElement
	bodyEntries := aCollectionOfXmlElement! !

!SoapBody methodsFor: 'elements' stamp: 'mu 4/27/2001 00:18'!
fault
	^ fault! !

!SoapBody methodsFor: 'elements' stamp: 'mu 5/5/2001 01:50'!
fault: aSoapFault
	fault := aSoapFault.
	aSoapFault parent: self! !


!SoapBody methodsFor: 'private-printing' stamp: 'mu 5/5/2001 01:39'!
privPrintChildrenOn: aStream indent: level 
	fault isNil
		ifFalse: [self fault printXmlOn: aStream indent: level].
	bodyEntries isNil
		ifFalse: [self bodyEntries
				do: [:each | each printXmlOn: aStream indent: level]].
	super privPrintChildrenOn: aStream indent: level! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapBody class
	instanceVariableNames: ''!

!SoapBody class methodsFor: 'instance creation' stamp: 'mu 1/16/2002 02:01'!
fromXmlElement: anXmlWrapElement 
	| inst faultElem |
	inst := self named: anXmlWrapElement name.
	self addAttributesOf: anXmlWrapElement to: inst.
	faultElem := anXmlWrapElement findChildLocalNamed: SoapFault localName.
	faultElem isNil
		ifTrue: [anXmlWrapElement children
				do: [:each | inst addBodyEntry: each]]
		ifFalse: [inst
				fault: (SoapFault fromXmlElement: faultElem)].
	^ inst! !


!SoapBody class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:04'!
localName
	^'Body'! !


SoapElement subclass: #SoapEnvelope
	instanceVariableNames: 'header body '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapEnvelope commentStamp: '<historical>' prior: 0!
SOAP Envelope element.


---
mu 5/21/2001 22:24!


!SoapEnvelope methodsFor: 'initialize-release' stamp: 'mu 8/12/2001 20:27'!
initialize
	super initialize.
	
	self declareDefaultNamespace.
	
	
	! !


!SoapEnvelope methodsFor: 'testing' stamp: 'mu 5/29/2002 23:54'!
hasFault
	^self body hasFault ! !

!SoapEnvelope methodsFor: 'testing' stamp: 'mu 4/22/2001 02:44'!
hasHeader
	^self header notNil
	! !

!SoapEnvelope methodsFor: 'testing' stamp: 'mu 1/14/2002 02:45'!
isEnvelope
	^true! !


!SoapEnvelope methodsFor: 'actions' stamp: 'mu 10/27/2001 21:07'!
addBody
	| bo |
	bo := SoapBody new.
	bo parent: self.
	self body: bo.
	^bo
	! !

!SoapEnvelope methodsFor: 'actions' stamp: 'mu 10/27/2001 21:08'!
addHeader
	| he |
	he := SoapHeader new.
	he parent: self.
	self header: he.
	^he! !


!SoapEnvelope methodsFor: 'elements' stamp: 'mu 8/12/2001 20:56'!
body
	body isNil
		ifTrue: [self addBody].
	^ body! !

!SoapEnvelope methodsFor: 'elements' stamp: 'mu 4/22/2001 02:43'!
body: aSoapBody
	body := aSoapBody.
	aSoapBody parent: self! !

!SoapEnvelope methodsFor: 'elements' stamp: 'mu 4/22/2001 00:43'!
header
	^ header! !

!SoapEnvelope methodsFor: 'elements' stamp: 'mu 4/22/2001 02:43'!
header: aSoapHeader
	header := aSoapHeader.
	aSoapHeader parent: self! !


!SoapEnvelope methodsFor: 'private-printing' stamp: 'mu 5/5/2001 01:41'!
privPrintChildrenOn: aStream indent: level
	self header isNil ifFalse:[self header printXmlOn: aStream indent: level].
	self body printXmlOn: aStream indent: level. "##body always exists##"
	super privPrintChildrenOn: aStream indent: level! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEnvelope class
	instanceVariableNames: ''!

!SoapEnvelope class methodsFor: 'instance creation' stamp: 'mu 1/16/2002 02:04'!
fromXmlElement: anXmlWrapElement 
	| inst headElem bodyElem others |
	inst := self named: anXmlWrapElement name.
	self addAttributesOf: anXmlWrapElement to: inst.
	headElem := anXmlWrapElement findChildLocalNamed: SoapHeader localName.
	headElem isNil
		ifFalse: [inst
				header: (SoapHeader fromXmlElement: headElem)].
	bodyElem := anXmlWrapElement findChildLocalNamed: SoapBody localName.
	bodyElem isNil
		ifFalse: [inst
				body: (SoapBody fromXmlElement: bodyElem)].
	others := anXmlWrapElement children
				reject: [:each | each localName = SoapHeader localName
						or: [each localName = SoapBody localName]]. "will be obsolete in SOAP 1.2"
	others
		do: [:otherE | inst addSubElement: otherE].
	^ inst! !


!SoapEnvelope class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:04'!
localName
	^'Envelope'! !


SoapElement subclass: #SoapFault
	instanceVariableNames: 'faultcode faultstring faultactor detail '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapFault commentStamp: '<historical>' prior: 0!
SOAP Fault element.


---
mu 5/21/2001 22:24!


!SoapFault methodsFor: 'initialize-release' stamp: 'mu 5/3/2001 01:06'!
initialize
	super initialize.
	faultcode := faultstring := ''
	! !


!SoapFault methodsFor: 'actions' stamp: 'mu 10/27/2001 21:06'!
addDetail
	| de |
	de := SoapFaultDetail new.
	de parent: self.
	self detail: de.
	^de! !

!SoapFault methodsFor: 'actions' stamp: 'mu 5/3/2001 19:16'!
attachMinorFaultCodes: aArrayOfString 
	| origFaultCode wStr |
	origFaultCode := self faultcode.
	wStr := WriteStream with: origFaultCode.
	aArrayOfString
		do: [:each | 
			wStr nextPut: $..
			wStr nextPutAll: each].
	^self faultcode: wStr contents! !


!SoapFault methodsFor: 'actions-faultcode' stamp: 'mu 10/27/2001 20:28'!
client
	self faultcode: (SoapConstants soapEnvPrefixColon, SoapConstants client)! !

!SoapFault methodsFor: 'actions-faultcode' stamp: 'mu 10/27/2001 20:29'!
mustUnderstand
	self faultcode: (SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstand)! !

!SoapFault methodsFor: 'actions-faultcode' stamp: 'mu 10/27/2001 20:28'!
server
	self faultcode: (SoapConstants soapEnvPrefixColon, SoapConstants server)! !

!SoapFault methodsFor: 'actions-faultcode' stamp: 'mu 10/27/2001 20:28'!
versionMismatch
	self faultcode: (SoapConstants soapEnvPrefixColon, SoapConstants versionMismatch)! !


!SoapFault methodsFor: 'testing' stamp: 'MU 11/7/2000 17:47'!
isFault
	^true! !


!SoapFault methodsFor: 'elements' stamp: 'mu 4/27/2001 00:27'!
detail
	^ detail! !

!SoapFault methodsFor: 'elements' stamp: 'MU 11/7/2000 19:33'!
detail: aValue

	detail := aValue! !

!SoapFault methodsFor: 'elements' stamp: 'MU 11/7/2000 19:33'!
faultactor

	^faultactor! !

!SoapFault methodsFor: 'elements' stamp: 'MU 11/7/2000 19:33'!
faultactor: aValue

	faultactor := aValue! !

!SoapFault methodsFor: 'elements' stamp: 'mu 4/27/2001 00:26'!
faultcode
	^faultcode! !

!SoapFault methodsFor: 'elements' stamp: 'MU 11/7/2000 19:33'!
faultcode: aValue

	faultcode := aValue! !

!SoapFault methodsFor: 'elements' stamp: 'mu 4/27/2001 00:27'!
faultstring
	^faultstring! !

!SoapFault methodsFor: 'elements' stamp: 'MU 11/7/2000 19:33'!
faultstring: aValue

	faultstring := aValue! !


!SoapFault methodsFor: 'private-printing' stamp: 'mu 5/3/2001 01:47'!
privPrintChildrenOn: aStream indent: level
	self writeValue: self faultcode on: aStream betweenTag: 'faultcode'.
	self writeValue: self faultstring on: aStream betweenTag: 'faultstring'.
	self faultactor isNil ifFalse:[self writeValue: self faultactor on: aStream betweenTag: 'faultactor'].
	self detail isNil ifFalse:[self detail printXmlOn: aStream].
	super privPrintChildrenOn: aStream indent: level! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapFault class
	instanceVariableNames: ''!

!SoapFault class methodsFor: 'instance creation' stamp: 'mu 5/3/2001 01:59'!
client
	^self new client! !

!SoapFault class methodsFor: 'instance creation' stamp: 'mu 1/16/2002 02:30'!
fromXmlElement: anXmlWrapElement 
	| inst faultcode faultstring faultactor detail others |
	inst := self named: anXmlWrapElement name.
	self addAttributesOf: anXmlWrapElement to: inst.
	faultcode := anXmlWrapElement findChildNamed: 'faultcode'.
	faultcode isNil	ifFalse: [inst faultcode: faultcode value].
	faultstring := anXmlWrapElement findChildNamed: 'faultstring'.
	faultstring isNil	ifFalse: [inst faultstring: faultstring value].
	faultactor := anXmlWrapElement findChildNamed: 'faultactor'.
	faultactor isNil	ifFalse: [inst faultactor: faultactor value].
	detail := anXmlWrapElement findChildNamed: 'detail'.
	detail isNil	ifFalse: [inst detail: (SoapFaultDetail fromXmlElement: detail)].
	others := anXmlWrapElement children
				reject: [:each | #('faultcode' 'faultstring' 'faultactor' 'detail') includes: each name].
	others	do: [:otherE | inst addSubElement: otherE].
	^ inst! !

!SoapFault class methodsFor: 'instance creation' stamp: 'mu 5/3/2001 01:59'!
mustUnderstand
	^self new mustUnderstand! !

!SoapFault class methodsFor: 'instance creation' stamp: 'mu 5/3/2001 01:59'!
server
	^self new server! !

!SoapFault class methodsFor: 'instance creation' stamp: 'mu 5/3/2001 02:00'!
versionMismatch
	^self new versionMismatch! !


!SoapFault class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:05'!
localName
	^'Fault'! !


SoapElement subclass: #SoapFaultDetail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapFaultDetail commentStamp: '<historical>' prior: 0!
SOAP Fault Detail element.


---
mu 5/21/2001 22:24!


!SoapFaultDetail methodsFor: 'initialize-release' stamp: 'mu 1/16/2002 02:21'!
initialize
	super initialize.
	name := self class localName! !


!SoapFaultDetail methodsFor: 'testing' stamp: 'mu 1/14/2002 02:45'!
isFaultDetail
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapFaultDetail class
	instanceVariableNames: ''!

!SoapFaultDetail class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:05'!
localName
	^'detail'! !


!SoapFaultDetail class methodsFor: 'instance creation' stamp: 'mu 1/16/2002 02:29'!
named: anElementName 
	"No namespace prefix check"
	^ self new name: anElementName! !


SoapElement subclass: #SoapHeader
	instanceVariableNames: 'headerEntries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Elements'!
!SoapHeader commentStamp: '<historical>' prior: 0!
SOAP Header element.


---
mu 5/21/2001 22:24!


!SoapHeader methodsFor: 'actions' stamp: 'mu 5/5/2001 01:47'!
addHeaderEntry: anXmlElement
	"anXmlElement mustUnderstand:
		#printXmlOn:aStream
		#parent: anXmlElement"
	anXmlElement parent: self.
	^self headerEntries add: anXmlElement.! !

!SoapHeader methodsFor: 'actions' stamp: 'mu 4/22/2001 02:38'!
disableMustUnderstand
	self putAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstand value: '0'! !

!SoapHeader methodsFor: 'actions' stamp: 'mu 4/22/2001 02:38'!
enableMustUnderstand
	self putAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstand value: '1'! !

!SoapHeader methodsFor: 'actions' stamp: 'mu 4/22/2001 02:38'!
isMustUnderstandEnabled
	^(self getAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstand ) = '1'! !


!SoapHeader methodsFor: 'elements' stamp: 'mu 5/5/2001 01:43'!
headerEntries
	headerEntries isNil ifTrue: [headerEntries := OrderedCollection new].
	^headerEntries! !

!SoapHeader methodsFor: 'elements' stamp: 'mu 5/5/2001 01:44'!
headerEntries: aCollectionOfXmlElement
	headerEntries := aCollectionOfXmlElement! !


!SoapHeader methodsFor: 'testing' stamp: 'mu 1/14/2002 02:45'!
isHeader
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapHeader class
	instanceVariableNames: ''!

!SoapHeader class methodsFor: 'constants' stamp: 'mu 1/12/2002 03:05'!
localName
	^'Header'! !
