SoapDataBinder subclass: #SoapAbstractEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!

!SoapAbstractEncoder methodsFor: 'actions' stamp: 'mu 7/13/2001 23:37'!
encodeSoapVariable: aSoapVariable
	self subclassResponsibility! !


!SoapAbstractEncoder methodsFor: 'factory' stamp: 'mu 7/14/2001 00:36'!
xmlElementClass
	^SoapWrapElement! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapAbstractEncoder class
	instanceVariableNames: ''!

!SoapAbstractEncoder class methodsFor: 'class initialization' stamp: 'mu 8/26/2001 01:19'!
initTypeDict
	"Apparently this mapping is not so sophisticted. "
	"##TODO: Implement more serious mapping method "
	| pref |
	typeDict := super initTypeDict.
	pref := SoapConstants xsdPrefixColon.
	#(
	#(#Boolean #boolean)
	#(#Float #float)
	#(#Double #double)
	#(#Integer #integer)
	#(#SmallInteger #integer)
	#(#LargePositiveInteger #positiveInteger)
	#(#LargeNegativeInteger #negativeInteger)
	#(#String #string)
	) do:[:each | typeDict at: each first put: (pref, each last)].
	^typeDict! !


SoapWrapElement subclass: #SoapEncArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!

!SoapEncArray methodsFor: 'actions' stamp: 'MU 4/27/2002 01:33'!
trimForNested
	self beShortName.
	self undeclareNamespaces.
	self trimElementTypeAttributePrefix! !


!SoapEncArray methodsFor: 'private' stamp: 'MU 4/27/2002 01:28'!
trimElementTypeAttributePrefix
	self attributesHolder trimAttributePrefixNamed: SoapConstants arrayType! !


!SoapEncArray methodsFor: 'testing' stamp: 'MU 3/24/2002 00:20'!
isArrayType
	"for performance"
	^true
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEncArray class
	instanceVariableNames: ''!

!SoapEncArray class methodsFor: 'instance creation' stamp: 'MU 3/18/2002 01:09'!
fromArray: anArray
	^self fromArray: anArray named: 'Array'
	! !

!SoapEncArray class methodsFor: 'instance creation' stamp: 'MU 3/25/2002 01:09'!
fromArray: anArray named: elemName
	^self fromArray: anArray named: elemName elementType: (SoapConstants xsdAnyType)
	! !

!SoapEncArray class methodsFor: 'instance creation' stamp: 'MU 8/5/2002 23:56'!
fromArray: anArray named: elemName elementType: anXSDType 
	^self fromArray: anArray named: elemName elementType: anXSDType containerType: nil namespace: nil! !

!SoapEncArray class methodsFor: 'instance creation' stamp: 'MU 8/5/2002 23:58'!
fromArray: anArray named: elemName elementType: elementXSDType containerType: arrayXSDType namespace: namespaceURI
	| inst encPrefix |
	encPrefix := SoapConstants soapEncPrefix.
	inst := self named: elemName.
	inst declareNamespace: encPrefix uri: SoapConstants soapEncURI.
	inst declareXsdNamespace.
	inst declareXsiNamespace.
	(namespaceURI notNil)
		ifTrue: [| prefix | 
			prefix := arrayXSDType isNil
						ifTrue: [SoXmlUtil randomPrefix]
						ifFalse: [SoXmlUtil prefixFrom: arrayXSDType].
			inst declareNamespace: prefix uri: namespaceURI].
	inst putAttributeNamed: SoapConstants arrayType value: elementXSDType , '[' , anArray size printString , ']'.
	anArray
		do: [:each | (each isNil
					or: [each == #nil])
				ifFalse: [| item child | 
					item := SoapVariable name: 'item' value: each.
					child := item encoder encodeSoapVariable: item.
					inst addChild: child]].
	^ inst! !


Object subclass: #SoapEncStruct
	instanceVariableNames: 'name dictionary xsdType namespace '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 4/21/2002 01:07'!
dictionary
	^dictionary! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 4/21/2002 01:07'!
dictionary: aDictionary
	dictionary := aDictionary! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 4/21/2002 01:06'!
name
	^name! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 4/21/2002 01:07'!
name: aString
	name := aString! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 8/7/2002 22:35'!
namespace
	^namespace! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 8/7/2002 22:36'!
namespace: namespaceURI
	namespace := namespaceURI! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 8/7/2002 22:35'!
xsdType
	^xsdType! !

!SoapEncStruct methodsFor: 'accessing' stamp: 'MU 8/7/2002 22:35'!
xsdType: aString
	xsdType := aString! !


!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:09'!
at: key
	^self dictionary at: key! !

!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:09'!
at: key ifAbsent: aBlock
	^self dictionary at: key ifAbsent: aBlock! !

!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:10'!
at: key put: value
	^self dictionary at: key put: value! !

!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:09'!
keys
	^self dictionary keys! !

!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:08'!
keysAndValuesDo: aBlock
	^self dictionary keysAndValuesDo: aBlock! !

!SoapEncStruct methodsFor: 'actions' stamp: 'MU 4/21/2002 01:09'!
values
	^self dictionary values! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEncStruct class
	instanceVariableNames: ''!

!SoapEncStruct class methodsFor: 'instance creation' stamp: 'MU 4/21/2002 01:07'!
fromDictionary: aDictionary named: elemName 
	^ self new dictionary: aDictionary;
		 name: elemName! !

!SoapEncStruct class methodsFor: 'instance creation' stamp: 'MU 8/7/2002 22:55'!
fromDictionary: aDictionary xsdType: xsdType namespace: namespaceURI 
	^ self new dictionary: aDictionary;
		 xsdType: xsdType;
		 namespace: namespaceURI! !


SoapAbstractEncoder subclass: #SoapEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!
!SoapEncoder commentStamp: 'MU 10/5/2002 01:33' prior: 0!
I will do SOAP encoding which is documented in SOAP 1.1 (1.2) spec.
Note that I am only one of the eocodings for SOAP.

---
MU 10/5/2002 01:32!


!SoapEncoder methodsFor: 'actions' stamp: 'MU 4/18/2003 16:59'!
encodeSoapVariable: aSoapVariable 
	| elem val type xsiTypeAttVal  |
	elem := self xmlElementClass named: aSoapVariable name.
	aSoapVariable isReferredValue
		ifFalse: [val := aSoapVariable value.
			val isNil ifTrue: [^ self encodeNilSoapVariable: aSoapVariable].
			type := aSoapVariable type.
			type isNil ifTrue: [type := val class name].
			(type == #Array or: [type == #SoapEncArray])
				ifTrue: [^ self encodeArraySoapVariable: aSoapVariable].
			((type == #Dictionary or: [type == #IdentityDictionary])
					or: [type == #SoapEncStruct])
				ifTrue: [^ self encodeDictionarySoapVariable: aSoapVariable].
			xsiTypeAttVal := aSoapVariable xsdType.
			xsiTypeAttVal isNil
				ifTrue: [xsiTypeAttVal := self class typeDict
								at: type
								ifAbsent: [SoapEncodingError signal: type printString , '''s encoding is not supported by ' , self class printString]].
			elem xsiType: xsiTypeAttVal asString].
	self setXmlElementId: aSoapVariable into: elem.
	self setXmlElementHref: aSoapVariable into: elem.
	self setXmlElementNamespace: aSoapVariable into: elem.
	self
		setXmlElementValue: aSoapVariable
		of: xsiTypeAttVal
		into: elem.
	^ elem! !


!SoapEncoder methodsFor: 'private' stamp: 'MU 8/5/2002 23:57'!
encodeArraySoapVariable: aSoapVariable 
	| arr allTypes elemType |
	arr := aSoapVariable value.
	arr class name == #SoapEncArray
		ifTrue: [^ arr trimForNested "temporary hack"].
	allTypes := arr
				collect: [:each | each class].
	elemType := (allTypes asSet size > 1
					or: [allTypes isEmpty])
				ifTrue: [SoapConstants xsdAnyType]
				ifFalse: [self class typeDict
						at: allTypes first name
						ifAbsent: [SoapConstants xsdAnyType]].
	^ SoapEncArray
		fromArray: arr
		named: aSoapVariable name
		elementType: elemType
		containerType: aSoapVariable xsdType
		namespace: aSoapVariable namespace! !

!SoapEncoder methodsFor: 'private' stamp: 'MU 8/7/2002 22:48'!
encodeDictionarySoapVariable: aSoapVariable 
	| elem dictOrStruct |
	elem := self xmlElementClass named: aSoapVariable name.
	dictOrStruct := aSoapVariable value.
	aSoapVariable value class name == #SoapEncStruct "Temporal hack"
		ifTrue: [elem parent isNil
				ifTrue: [elem declareXsiNamespace].
			dictOrStruct xsdType isNil
				ifTrue: [elem xsiType: dictOrStruct name]
				ifFalse: [elem xsiType: dictOrStruct xsdType.
					dictOrStruct namespace isNil
						ifFalse: [elem
								declareNamespace: (SoXmlUtil prefixFrom: dictOrStruct xsdType)
								uri: dictOrStruct namespace]]].
	dictOrStruct
		keysAndValuesDo: [:k :v | elem
				addChild: (self
						encodeSoapVariable: (SoapVariable name: k value: v))].
	^ elem! !

!SoapEncoder methodsFor: 'private' stamp: 'mu 1/1/2002 20:54'!
encodeNilSoapVariable: aSoapVariable 
	| elem |
	^self class useXsiNullAttribute
		ifTrue: [elem := self xmlElementClass emptyNamed: aSoapVariable name.
			elem putAttributeNamed: SoapConstants xsiNil value: 1.
			elem]
		ifFalse: [nil]! !

!SoapEncoder methodsFor: 'private' stamp: 'MU 1/8/2003 02:12'!
setXmlElementHref: aSoapVariable into: anXmlElement 
	| href |
	href := aSoapVariable href.
	href isNil
		ifFalse: [anXmlElement href: href.
			anXmlElement beEmpty].
	^ anXmlElement! !

!SoapEncoder methodsFor: 'private' stamp: 'MU 1/8/2003 02:05'!
setXmlElementId: aSoapVariable into: anXmlElement 
	| id |
	id := aSoapVariable id.
	id isNil
		ifFalse: [anXmlElement id: id].
	^ anXmlElement! !

!SoapEncoder methodsFor: 'private' stamp: 'MU 8/5/2002 23:23'!
setXmlElementNamespace: aSoapVariable into: anXmlElement 
	| ns |
	ns := aSoapVariable namespace.
	ns isNil
		ifFalse: [| prefix | 
			prefix := aSoapVariable xsdType isNil
						ifTrue: [SoXmlUtil randomPrefix]
						ifFalse: [SoXmlUtil prefixFrom: aSoapVariable xsdType].
			anXmlElement declareNamespace: prefix uri: ns].
	^anXmlElement! !

!SoapEncoder methodsFor: 'private' stamp: 'MU 5/11/2002 03:21'!
setXmlElementValue: aSoapVariable of: xsiTypeString into: anXmlElement 
	| elem type value |
	elem := anXmlElement.
	type := xsiTypeString.
	value := aSoapVariable value.
	"default, just set raw data"
	elem value: value.

	"otherwise"
	type = SoapConstants xsdBase64BinaryType
		ifTrue: [| encValue | 
			encValue := (Base64MimeConverter mimeEncode: value asByteArray readStream) contents.
			^ elem value: encValue]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEncoder class
	instanceVariableNames: 'useXsiNullAttribute '!

!SoapEncoder class methodsFor: 'class initialiation' stamp: 'MU 4/21/2002 00:59'!
initTypeDict
	"Apparently this mapping is not mature. "
	"##TODO: Implement more serious mapping"
	| pref |
	typeDict := super initTypeDict.
	pref := SoapConstants xsdPrefixColon.
	#(
	#(#Any #any)
	#(#DateAndTime #dateTime)
	#(#Time #time)
	#(#Date #date)
	#(#Boolean #boolean)
	#(#True #boolean)
	#(#False #boolean)
	#(#Array #Array)
	#(#ByteArray #base64Binary)
	#(#Float #float)
	#(#Double #double)
	#(#Integer #integer)
	#(#SmallInteger #integer)
	#(#LargePositiveInteger #positiveInteger)
	#(#LargeNegativeInteger #negativeInteger)
	#(#Byte #byte)
	#(#String #string)
	#(#Symbol #string)
	) do:[:each | typeDict at: each first put: (pref, each last) asSymbol].
	! !

!SoapEncoder class methodsFor: 'class initialiation' stamp: 'mu 7/1/2001 23:47'!
initialize
	"SoapEncoder initialize"
	super initialize.
	useXsiNullAttribute := false.

	
	! !


!SoapEncoder class methodsFor: 'setting' stamp: 'mu 6/28/2001 01:04'!
useXsiNullAttribute
	^useXsiNullAttribute! !

!SoapEncoder class methodsFor: 'setting' stamp: 'mu 6/28/2001 01:05'!
useXsiNullAttribute: aBoolean
	useXsiNullAttribute := aBoolean! !


SoapDataBindingFactory subclass: #SoapEncoderFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEncoderFactory class
	instanceVariableNames: ''!

!SoapEncoderFactory class methodsFor: 'default values' stamp: 'MU 10/15/2002 00:00'!
initDataBindingDict
	self dataBindingDict at: SoapConstants nullEncURI put: SoapNullEncoder.
	self dataBindingDict at: SoapConstants soapEncURI put: SoapEncoder.
	self dataBindingDict at: SoapConstants soapSqEncURI put: SoapSqEncoder.! !


!SoapEncoderFactory class methodsFor: 'accessing-error' stamp: 'mu 10/6/2001 20:39'!
noSuchDataBinder
	^SoapNoSuchEncoder
	! !


SoapDatabindingError subclass: #SoapEncodingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!


SoapNoSuchDataBinder subclass: #SoapNoSuchEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!


SoapAbstractEncoder subclass: #SoapNullEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!

!SoapNullEncoder methodsFor: 'actions' stamp: 'MU 10/15/2002 00:57'!
encodeSoapVariable: aSoapVariable 
	| elem val |
	elem := self xmlElementClass named: aSoapVariable name.
	val := aSoapVariable value.
	elem putAttributeNamed: SoapConstants xsiType value: SoapConstants nullEncPrefixColon , aSoapVariable value class name.
	
	elem basicValue: val.
	^ elem! !


SoapAbstractEncoder subclass: #SoapSqEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Encoding'!
!SoapSqEncoder commentStamp: 'MU 10/5/2002 01:34' prior: 0!
I will do Squeak specific encoding for SOAP, using ReferenceStream.
Note that I am only one of the eocodings for SOAP.

---
MU 10/5/2002 01:32!


!SoapSqEncoder methodsFor: 'actions' stamp: 'mu 8/26/2001 01:16'!
encodeSoapVariable: aSoapVariable
	| val type xsiTypeAttVal elem |
	val := aSoapVariable value.
	val isNil ifTrue:[^self encodeNilSoapVariable: aSoapVariable ].
	type := aSoapVariable type.
	type isNil ifTrue:[type := val class name].
	xsiTypeAttVal := self typeDict at: type ifAbsent:[ ^self encodeObjectSoapVariable: aSoapVariable].
	elem := self xmlElementClass named: aSoapVariable name.
	elem putAttributeNamed: (SoapConstants xsiType) value: xsiTypeAttVal.
	elem value: aSoapVariable value.
	^elem! !


!SoapSqEncoder methodsFor: 'private' stamp: 'mu 7/1/2001 23:39'!
encodeNilSoapVariable: aSoapVariable 
	| elem |
	elem := self xmlElementClass emptyNamed: aSoapVariable name.
	elem putAttributeNamed: SoapConstants xsiPrefixColon , 'null' value: 1.
	^elem! !

!SoapSqEncoder methodsFor: 'private' stamp: 'mu 12/28/2001 01:59'!
encodeObjectSoapVariable: aSoapVariable
	| val  valStr elem |
	val := aSoapVariable value.
	valStr := self stringFromObject: val.
	elem := self xmlElementClass named: aSoapVariable name.
	elem putAttributeNamed: (SoapConstants xsiType) value: (SoapConstants sqEncPrefixColon, self defaultObjectEncoderClass name).
	elem value: valStr.
	^elem! !

!SoapSqEncoder methodsFor: 'private' stamp: 'mu 12/28/2001 01:57'!
stringFromObject: anObject
	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(self defaultObjectEncoderClass on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents
	! !


!SoapSqEncoder methodsFor: 'defaults' stamp: 'mu 12/28/2001 18:25'!
defaultObjectEncoderClass
	^ReferenceStream! !

SoapEncoder initialize!