Object subclass: #GoogleClient
	instanceVariableNames: 'licenseKey doGetCachedPage doSpellingSuggestion doGoogleSearch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-GoogleWebAPI'!
!GoogleClient commentStamp: '<historical>' prior: 0!
I am an example that accesses Google Web APIs by SoapOpera.

About Google Web API:
http://www.google.com/apis/index.html

---
MU 5/12/2002 00:51!


!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 03:26'!
cachedPageOf: urlString
	| params resp |
	params := OrderedCollection with: self licenseKey.
	params add: urlString.
	resp := self doGetCachedPage invokeWithValues: params.
	^ resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue asString]! !

!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 02:26'!
search: query
	^ self
		search: query
		start: 0
		maxResults: 10
		! !

!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 02:26'!
search: query start: start maxResults: maxResults
	^ self
		search: query
		start: start
		maxResults: maxResults
		filter: true
		restrict: ''
		safeSearch: false
		languageRestrict: '' ! !

!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 02:20'!
search: query start: start maxResults: maxResults filter: filter restrict: restrict safeSearch: safeSearch languageRestrict: lr 
	^ self
		search: query
		start: start
		maxResults: maxResults
		filter: filter
		restrict: restrict
		safeSearch: safeSearch
		languageRestrict: lr
		inputEncoding: 'utf8'
		outputEncoding: 'utf8'! !

!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 02:35'!
search: query start: start maxResults: maxResults filter: filter restrict: restrict safeSearch: safeSearch languageRestrict: lr inputEncoding: ie outputEncoding: oe 
	| params resp |
	params := OrderedCollection with: self licenseKey.
	params add: query;
		 add: start;
		 add: maxResults;
		 add: filter;
		 add: restrict;
		 add: safeSearch;
		 add: lr;
		 add: ie;
		 add: oe.
	resp := self doGoogleSearch invokeWithValues: params.
	^ resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !

!GoogleClient methodsFor: 'actions' stamp: 'MU 5/11/2002 02:44'!
spellingSuggestionOf: phrase
	| params resp |
	params := OrderedCollection with: self licenseKey.
	params add: phrase.
	resp := self doSpellingSuggestion invokeWithValues: params.
	^ resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !


!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:35'!
callEntry
	^self class callEntry! !

!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 01:31'!
doGetCachedPage
	doGetCachedPage isNil ifTrue: [doGetCachedPage := self buildDoGetCachedPage].
	^doGetCachedPage! !

!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 01:31'!
doGoogleSearch
	doGoogleSearch isNil ifTrue: [doGoogleSearch := self buildDoGoogleSearch].
	^doGoogleSearch! !

!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 01:32'!
doSpellingSuggestion
	doSpellingSuggestion isNil ifTrue: [doSpellingSuggestion := self buildDoSpellingSuggestion].
	^doSpellingSuggestion! !

!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 02:30'!
licenseKey
	licenseKey isNil ifTrue: [licenseKey := self class licenseKey].
	^licenseKey! !

!GoogleClient methodsFor: 'accessing' stamp: 'MU 5/11/2002 02:30'!
licenseKey: key
	licenseKey := key! !


!GoogleClient methodsFor: 'private' stamp: 'MU 5/11/2002 02:41'!
buildDoGetCachedPage
	| call |
	call := self newCall.
	call methodName: 'doGetCachedPage'.
	call addParameterNamed: #key.
	call addParameterNamed: #url.
	^call! !

!GoogleClient methodsFor: 'private' stamp: 'MU 5/11/2002 00:57'!
buildDoGoogleSearch
	| call |
	call := self newCall.
	call methodName: 'doGoogleSearch'.
	call addParameterNamed: #key.
	call addParameterNamed: #q. 
	call addParameterNamed: #start xsdType: 'xsd:int'.
	call addParameterNamed: #maxResults xsdType: 'xsd:int'.
	call addParameterNamed: #filter.
	call addParameterNamed: #restrict.
	call addParameterNamed: #safeSearch.
	call addParameterNamed: #lr.
	call addParameterNamed: #ie.
	call addParameterNamed: #oe.
	^call! !

!GoogleClient methodsFor: 'private' stamp: 'MU 5/11/2002 02:40'!
buildDoSpellingSuggestion
	| call |
	call := self newCall.
	call methodName: 'doSpellingSuggestion'.
	call addParameterNamed: #key.
	call addParameterNamed: #phrase.
	^call! !

!GoogleClient methodsFor: 'private' stamp: 'MU 5/11/2002 00:53'!
newCall
	| call |
	call := self callEntry newCall.
	call targetObjectURI: self class targetObjectURI.
	call namespace: self class namespace.
	^call! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoogleClient class
	instanceVariableNames: 'licenseKey callEntry targetObjectURI namespace host port '!

!GoogleClient class methodsFor: 'documentation' stamp: 'MU 5/12/2002 01:31'!
howToUse
	"##GoogleClient is an example that accesses Google Web APIs by SoapOpera.##"
	
	"1: Preparations
	 In order to call Google Web APIs, you need a Google Account license key. (It is free).
	 The license key is obtained from: http://www.google.com/apis/index.html
	 Then, please set the license key by: GoogleClient licenseKey: 'yourkey' 
	"
	
	"2: Usages (explore or print it)
	 GoogleClient new search: 'Google Web APIs Reference'. 
	 GoogleClient new spellingSuggestionOf: 'Smmalltlaak and Soaap'.
	 GoogleClient new cachedPageOf: 'http://www.squeak.org'
	"
	! !


!GoogleClient class methodsFor: 'class initialization' stamp: 'MU 5/12/2002 00:57'!
initialize
	"GoogleClient initialize"
	"GoogleClient licenseKey: 'your key' (see the 'documentation' category first)"

	licenseKey := '00000000000000000000000000000000'.
	
	callEntry := targetObjectURI := namespace := host := port := nil.! !


!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:20'!
callEntry
	callEntry isNil ifTrue: [ callEntry := SoapCallEntry tcpHost: self host port: self port].
	^callEntry! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:15'!
callEntry: aValue

	callEntry := aValue! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:21'!
host
	host isNil ifTrue: [host := 'api.google.com'].
	^host! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:19'!
host: aValue

	host := aValue! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:04'!
licenseKey
	^licenseKey! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:12'!
licenseKey: aString
	"GoogleClient licenseKey: 'your key'"
	licenseKey := aString! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:22'!
namespace
	namespace isNil ifTrue: [namespace := 'urn:GoogleSearch'].
	^namespace! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:15'!
namespace: aValue

	namespace := aValue! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:20'!
port
	port isNil ifTrue: [port := 80].
	^port! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:19'!
port: aValue

	port := aValue! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:21'!
targetObjectURI
	targetObjectURI isNil ifTrue: [targetObjectURI := 'http://api.google.com/search/beta2'].
	^targetObjectURI! !

!GoogleClient class methodsFor: 'accessing' stamp: 'MU 5/11/2002 00:15'!
targetObjectURI: aValue

	targetObjectURI := aValue! !

GoogleClient initialize!