Object subclass: #SoapCallEntry
	instanceVariableNames: 'locator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!
!SoapCallEntry commentStamp: '<historical>' prior: 0!
I represent a SOAP RPC access point.

---
MU 5/12/2002 00:47!


!SoapCallEntry methodsFor: 'actions' stamp: 'mu 6/2/2001 03:17'!
newCall
	^SoapCall locator: (self locator)! !


!SoapCallEntry methodsFor: 'accessing' stamp: 'mu 6/2/2001 03:15'!
locator

	^locator! !

!SoapCallEntry methodsFor: 'accessing' stamp: 'mu 6/2/2001 03:15'!
locator: aValue

	locator := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapCallEntry class
	instanceVariableNames: 'defaultSendingPort '!

!SoapCallEntry class methodsFor: 'class initialization' stamp: 'MU 9/28/2002 18:21'!
initialize
	"SoapCallEntry initialize"
	defaultSendingPort := 8823! !


!SoapCallEntry class methodsFor: 'instance creation' stamp: 'MU 9/28/2002 18:22'!
local
	^self tcpHost: 'localhost' port: self defaultSendingPort 
	! !

!SoapCallEntry class methodsFor: 'instance creation' stamp: 'MU 9/28/2002 18:25'!
local: portNumberInteger
	^ self new
		locator: (SoapTcpLocator host: 'localhost' port: portNumberInteger)! !

!SoapCallEntry class methodsFor: 'instance creation' stamp: 'MU 9/28/2002 18:22'!
tcpHost: hostnameString
	^self tcpHost: hostnameString port: self defaultSendingPort! !

!SoapCallEntry class methodsFor: 'instance creation' stamp: 'mu 7/20/2001 01:01'!
tcpHost: hostnameString port: portNumberInteger
	"In many cases, these values are used for setting router server URI" 
	^ self new
		locator: (SoapTcpLocator host: hostnameString port: portNumberInteger)! !


!SoapCallEntry class methodsFor: 'accessing' stamp: 'MU 9/28/2002 18:21'!
defaultSendingPort
	^defaultSendingPort! !

!SoapCallEntry class methodsFor: 'accessing' stamp: 'MU 9/28/2002 18:21'!
defaultSendingPort: portNumber
	defaultSendingPort := portNumber! !


Object subclass: #SoapContext
	instanceVariableNames: 'propDict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!
!SoapContext commentStamp: 'MU 10/5/2002 01:17' prior: 0!
I represent a SOAP RPC context.

---
MU 5/12/2002 00:47!


!SoapContext methodsFor: 'actions' stamp: 'mu 12/21/2001 01:02'!
encodingStyleURIs
	^self at: #encodingStyleURIs ifAbsent:[#()]! !

!SoapContext methodsFor: 'actions' stamp: 'mu 10/13/2001 20:16'!
encodingStyleURIs: anArrayOfEncodingStyleURI
	self at: #encodingStyleURIs put: anArrayOfEncodingStyleURI! !

!SoapContext methodsFor: 'actions' stamp: 'mu 12/22/2001 01:37'!
soapAction
	^self at: #soapAction ifAbsent:[SoapAction intentByRequestURI]! !

!SoapContext methodsFor: 'actions' stamp: 'mu 12/19/2001 00:27'!
soapAction: aSoapAction
	self at: #soapAction put: aSoapAction! !

!SoapContext methodsFor: 'actions' stamp: 'mu 12/21/2001 01:01'!
targetObjectURI
	^self at: #targetObjectURI ifAbsent:['']! !

!SoapContext methodsFor: 'actions' stamp: 'mu 12/28/2001 18:48'!
targetObjectURI: aString
	self at: #targetObjectURI put: (SoPortableUtil relativeURIFrom: aString).! !


!SoapContext methodsFor: 'actions-basic' stamp: 'mu 7/20/2001 00:37'!
at: aSymbol
	^self propDict at: aSymbol! !

!SoapContext methodsFor: 'actions-basic' stamp: 'mu 9/24/2001 01:44'!
at: aSymbol ifAbsent: aBlock
	^self propDict at: aSymbol ifAbsent: aBlock! !

!SoapContext methodsFor: 'actions-basic' stamp: 'mu 7/20/2001 00:36'!
at: aSymbol put: anObject
	^self propDict at: aSymbol put: anObject! !


!SoapContext methodsFor: 'accessing' stamp: 'mu 7/20/2001 00:35'!
propDict
	propDict isNil ifTrue: [propDict := IdentityDictionary new].
	^propDict! !

!SoapContext methodsFor: 'accessing' stamp: 'mu 7/20/2001 00:35'!
propDict: aValue

	propDict := aValue! !


!SoapContext methodsFor: 'printing' stamp: 'mu 7/20/2001 01:51'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: ${.
	self propDict keysAndValuesDo:[:k :v | aStream print: k; nextPutAll: '->'; print: v; space].
	aStream nextPut: $}.! !


Object subclass: #SoapEncodable
	instanceVariableNames: 'encodingStyleURIs encoder parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 1/26/2002 23:49'!
encoder
	encoder isNil
		ifTrue: [encoder := parent isNil
						ifTrue: [SoapEncoderFactory createFrom: self encodingStyleURIs]
						ifFalse: [parent encoder]].
	^ encoder! !

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 6/12/2001 23:09'!
encoder: aValue

	encoder := aValue! !

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 6/6/2001 01:06'!
encodingStyleURIs
	encodingStyleURIs isNil ifTrue:[ encodingStyleURIs := Array with: SoapConstants soapEncURI].
	^encodingStyleURIs! !

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 5/26/2001 02:08'!
encodingStyleURIs: aValue

	encodingStyleURIs := aValue! !

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 8/4/2001 23:02'!
parent

	^parent! !

!SoapEncodable methodsFor: 'accessing' stamp: 'mu 8/4/2001 23:02'!
parent: aValue

	parent := aValue! !


!SoapEncodable methodsFor: 'actions' stamp: 'mu 1/26/2002 23:37'!
encoding: aSymbol
	self encodingStyleURI: (SoapEncodingStyleURIMap at: aSymbol).
	self encoder: (SoapEncoderFactory createFrom: self encodingStyleURIs).  ! !

!SoapEncodable methodsFor: 'actions' stamp: 'mu 5/26/2001 02:09'!
encodingStyleURI: aURIString
	self encodingStyleURIs: (Array with: aURIString)! !

!SoapEncodable methodsFor: 'actions' stamp: 'mu 8/5/2001 00:19'!
encodingStyleURIString
	| uris wStr |
	uris := self encodingStyleURIs.
	wStr := WriteStream
				on: (String new: 64).
	uris size = 1
		ifTrue: [wStr nextPutAll: uris first]
		ifFalse: [self encodingStyleURIs
				do: [:each | wStr nextPutAll: each;
						 nextPut: Character space]].
	^ wStr contents! !

!SoapEncodable methodsFor: 'actions' stamp: 'mu 5/26/2001 02:09'!
encodingStyleURIString: anEncodingStyleURI 
	self
		encodingStyleURIs: (SoPortableUtil substringsFrom: anEncodingStyleURI)! !


Object subclass: #SoapExceptionBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!

!SoapExceptionBuilder methodsFor: 'actions' stamp: 'MU 5/3/2002 02:04'!
buildExceptionFrom: aSoapFault 
	| exception |
	aSoapFault detail isNil
		ifTrue: [exception := SoapError fromSoapFault: aSoapFault]
		ifFalse: [| exceptionDetail errorClassTag exceptionClassName messageText | 
			exceptionDetail := aSoapFault detail subElements first.
			errorClassTag := exceptionDetail findChildNamed: 'ErrorClass'.
			exceptionClassName := errorClassTag isNil
						ifTrue: ['Error']
						ifFalse: [errorClassTag value].
			exception := (Smalltalk
						at: exceptionClassName asSymbol
						ifAbsent: [SoapNoSuchExceptionClass signal: exceptionClassName]) new.
			messageText := exceptionDetail findChildNamed: 'messageText'.
			exception
				messageText: (messageText isNil
						ifTrue: [aSoapFault faultstring]
						ifFalse: [messageText value])].
	exception tag: '<<signaled in server>>'.
	"Should I use tag?"
	^ exception! !


Object subclass: #SoapMessage
	instanceVariableNames: 'context envelope '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!

!SoapMessage methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:49'!
context
	context isNil ifTrue:[context := SoapContext new].
	^context! !

!SoapMessage methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:48'!
context: aValue

	context := aValue! !

!SoapMessage methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:48'!
envelope

	^envelope! !

!SoapMessage methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:48'!
envelope: aValue

	envelope := aValue! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapMessage class
	instanceVariableNames: ''!

!SoapMessage class methodsFor: 'actions' stamp: 'mu 10/27/2001 19:56'!
envelope: aSoapEnvelope
	^self envelope: aSoapEnvelope context: nil! !

!SoapMessage class methodsFor: 'actions' stamp: 'mu 10/27/2001 19:55'!
envelope: aSoapEnvelope context: aSoapContext
	^self new envelope: aSoapEnvelope; context: aSoapContext! !


SoapEncodable subclass: #SoapPRCElement
	instanceVariableNames: 'targetObjectURI methodName parameters optionSignature optionHeaderProperties transport envelope context namespace prefix '
	classVariableNames: 'DefaultNamespace DefaultPrefix '
	poolDictionaries: ''
	category: 'SOAP-RPC'!

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/22/2001 23:07'!
context
	context isNil ifTrue: [context := self buildContext].
	^context! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/22/2001 23:00'!
context: aValue

	context := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'MU 8/2/2002 01:27'!
envelope
	envelope isNil ifTrue: [envelope := SoapEnvelope new].
	^envelope! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/22/2001 22:59'!
envelope: aValue

	envelope := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/12/2001 23:18'!
methodName
	methodName isNil ifTrue: [methodName := ''].
	^methodName! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:17'!
methodName: aValue

	methodName := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:20'!
namespace
	namespace isNil ifTrue: [namespace := self class defaultNamespace].
	^namespace! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:20'!
namespace: aValue

	namespace := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/7/2001 01:24'!
optionHeaderProperties
	optionHeaderProperties isNil ifTrue: [optionHeaderProperties := Dictionary new].
	^optionHeaderProperties! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/2/2001 01:32'!
optionHeaderProperties: aValue

	optionHeaderProperties := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:17'!
optionSignature

	^optionSignature! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:17'!
optionSignature: aValue

	optionSignature := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/12/2001 23:19'!
parameters
	parameters isNil ifTrue: [parameters := OrderedCollection new].
	^parameters! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:17'!
parameters: aValue

	parameters := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:21'!
prefix
	prefix isNil ifTrue: [prefix := self class defaultPrefix].
	^prefix! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:20'!
prefix: aValue

	prefix := aValue! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/12/2001 23:19'!
targetObjectURI
	targetObjectURI isNil ifTrue: [targetObjectURI := ''].
	^targetObjectURI! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 12/28/2001 18:48'!
targetObjectURI: aString
	targetObjectURI := SoPortableUtil relativeURIFrom: aString.! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/6/2001 01:07'!
transport
	transport isNil ifTrue: [transport := #http].
	^transport! !

!SoapPRCElement methodsFor: 'accessing' stamp: 'mu 6/6/2001 01:01'!
transport: aValue

	transport := aValue! !


!SoapPRCElement methodsFor: 'testing' stamp: 'mu 6/7/2001 01:41'!
isCall
	^false! !

!SoapPRCElement methodsFor: 'testing' stamp: 'mu 6/7/2001 01:41'!
isResponse
	^false! !

!SoapPRCElement methodsFor: 'testing' stamp: 'mu 6/12/2001 23:45'!
isVariable
	^false! !


!SoapPRCElement methodsFor: 'building context' stamp: 'mu 7/22/2001 23:06'!
buildContext
	| ctx | 
	ctx := SoapContext new.
	ctx targetObjectURI: self targetObjectURI.
	^ctx! !


!SoapPRCElement methodsFor: 'actions-encoding' stamp: 'mu 7/30/2001 00:18'!
encoder: aValue 
	parameters notNil
		ifTrue: [self parameters
				do: [:each | each encoder: aValue]].
	super encoder: aValue.
	! !

!SoapPRCElement methodsFor: 'actions-encoding' stamp: 'mu 1/26/2002 23:38'!
encoding: aSymbol
	parameters notNil
		ifTrue: [self parameters
				do: [:each | each encoding: aSymbol]].
	super encoding: aSymbol.! !

!SoapPRCElement methodsFor: 'actions-encoding' stamp: 'mu 7/30/2001 00:19'!
encodingStyleURI: aURIString
	parameters notNil
		ifTrue: [self parameters
				do: [:each | each encodingStyleURI: aURIString]].
	super encodingStyleURI: aURIString.! !

!SoapPRCElement methodsFor: 'actions-encoding' stamp: 'mu 7/30/2001 00:19'!
encodingStyleURIString: anEncodingStyleURI 
	parameters notNil
		ifTrue: [self parameters
				do: [:each | each encodingStyleURIString: anEncodingStyleURI]].
	super encodingStyleURIString: anEncodingStyleURI.! !

!SoapPRCElement methodsFor: 'actions-encoding' stamp: 'mu 7/30/2001 00:19'!
encodingStyleURIs: aValue
	parameters notNil
		ifTrue: [self parameters
				do: [:each | each encodingStyleURIs: aValue]].
	super encodingStyleURIs: aValue.
	! !


!SoapPRCElement methodsFor: 'factory' stamp: 'mu 7/14/2001 00:35'!
xmlElementClass
	^SoapWrapElement! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapPRCElement class
	instanceVariableNames: ''!

!SoapPRCElement class methodsFor: 'class initialization' stamp: 'mu 7/14/2001 00:17'!
initialize
	"SoapPRCElement initialize"
	DefaultPrefix := DefaultNamespace := nil! !


!SoapPRCElement class methodsFor: 'actions' stamp: 'mu 5/4/2001 23:55'!
unmarshallFrom: aSoapEnvelope
	"create one of my family"! !


!SoapPRCElement class methodsFor: 'accessing' stamp: 'mu 11/3/2001 19:25'!
defaultNamespace
	DefaultNamespace isNil
		ifTrue: [DefaultNamespace := 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/'].
	^ DefaultNamespace! !

!SoapPRCElement class methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:17'!
defaultNamespace: aString
	DefaultNamespace := aString! !

!SoapPRCElement class methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:17'!
defaultPrefix
	DefaultPrefix isNil
		ifTrue: [DefaultPrefix := 'm'].
	^ DefaultPrefix
! !

!SoapPRCElement class methodsFor: 'accessing' stamp: 'mu 7/14/2001 00:18'!
defaultPrefix: aString
	DefaultPrefix := aString! !


SoapPRCElement subclass: #SoapCall
	instanceVariableNames: 'connector locator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!
!SoapCall commentStamp: '<historical>' prior: 0!
I represent a Remote Procedure Call in SOAP.

---
MU 5/12/2002 00:47!


!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 11/24/2002 15:55'!
invoke
	| returnedMsg resp | 
	self optionHeaderProperties keysAndValuesDo:[:k :v | self context at: k put: v].
	returnedMsg := self connector send: self buildEnvelope to: self locator with: self context.
	resp := SoapResponse fromSoapMessage: returnedMsg.
	self clear.
	^resp
	! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 12/9/2002 21:51'!
invokeAndReturn
	| resp |
	resp := self invoke.
	^ resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 12/9/2002 22:01'!
invokeAndReturnWithValue: value
	 | resp |
	resp := self invokeWithValue: value.
	^resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 12/9/2002 22:02'!
invokeAndReturnWithValues: values
	 | resp |
	resp :=  self invokeWithValues: values.
	^resp isFault
		ifTrue: [resp raiseException]
		ifFalse: [resp returnValue]! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 11/24/2002 15:55'!
invokeWithHeaderProperties: aHeaderProperties
	self headerProperties: aHeaderProperties.
	^self invoke! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 11/24/2002 15:55'!
invokeWithValue: value
	^self invokeWithValues: (Array with: value)! !

!SoapCall methodsFor: 'actions-invoking' stamp: 'MU 11/24/2002 15:55'!
invokeWithValues: values
	"assuming parameters had been added"
	| paramSize |
	paramSize := self parameters size.
	1 to: paramSize do:[:idx | (self parameters at: idx ) value: (values at: idx ifAbsent:[])].
	^self invoke! !


!SoapCall methodsFor: 'actions' stamp: 'mu 1/26/2002 23:49'!
addParameter: aSoapVariable
	aSoapVariable parent: self.
	^self parameters add: aSoapVariable! !

!SoapCall methodsFor: 'actions' stamp: 'MU 12/9/2002 22:22'!
addParameterArray: parameterArray
	"parameterArray -> {name. value(optional). xsdType(optional) }"
	| paramSize |
	paramSize := parameterArray size.
	paramSize = 1 ifTrue: [^self addParameterNamed: (parameterArray at: 1)].
	paramSize = 2 ifTrue: [^self addParameterNamed: (parameterArray at: 1) value: (parameterArray at: 2)].
	paramSize = 3 ifTrue: [^self addParameterNamed: (parameterArray at: 1) value: (parameterArray at: 2) xsdType: (parameterArray at: 3)].
	
	! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:14'!
addParameterNamed: paramName 
	^self addParameter: (SoapVariable name: paramName). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:14'!
addParameterNamed: paramName type: xsdType
	^self addParameter: (SoapVariable name: paramName type: xsdType). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:15'!
addParameterNamed: paramName value: paramValue
	^self addParameter: (SoapVariable name: paramName value: paramValue). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:15'!
addParameterNamed: paramName value: paramValue type: xsdType
	^self addParameter: (SoapVariable name: paramName value: paramValue type: xsdType). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:15'!
addParameterNamed: paramName value: paramValue xsdType: xsdType
	^self addParameter: (SoapVariable name: paramName value: paramValue xsdType: xsdType). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/6/2002 00:07'!
addParameterNamed: paramName value: paramValue xsdType: xsdType namespace: namespaceURI
	^self addParameter: (SoapVariable name: paramName value: paramValue xsdType: xsdType namespace: namespaceURI ). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:14'!
addParameterNamed: paramName xsdType: xsdType
	^self addParameter: (SoapVariable name: paramName xsdType: xsdType). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/6/2002 00:04'!
addParameterNamed: paramName xsdType: xsdType namespace: namespaceURI
	^self addParameter: (SoapVariable name: paramName xsdType: xsdType namespace: namespaceURI). ! !

!SoapCall methodsFor: 'actions' stamp: 'MU 12/9/2002 22:24'!
addParameters: parameterArrays
	^parameterArrays do: [:each | self addParameterArray: each]! !

!SoapCall methodsFor: 'actions' stamp: 'MU 8/2/2002 01:13'!
declareEnvelopeNamespace: prefixString uri: uri
	self envelope declareNamespace: prefixString uri: uri! !

!SoapCall methodsFor: 'actions' stamp: 'mu 7/20/2001 01:23'!
transport: aSymbol
	"need to reset connector"
	self connector: nil.
	super transport: aSymbol.! !


!SoapCall methodsFor: 'accessing' stamp: 'mu 7/20/2001 01:20'!
connector
	connector isNil ifTrue: [ connector := SoapConnectorFactory createFrom: self transport].
	^connector! !

!SoapCall methodsFor: 'accessing' stamp: 'mu 6/4/2001 23:50'!
connector: aValue

	connector := aValue! !

!SoapCall methodsFor: 'accessing' stamp: 'mu 7/20/2001 01:24'!
locator
	locator isNil ifTrue: [ locator := SoapCallEntry local locator].
	^locator! !

!SoapCall methodsFor: 'accessing' stamp: 'mu 6/2/2001 02:35'!
locator: aValue

	locator := aValue! !


!SoapCall methodsFor: 'building envelope' stamp: 'MU 8/2/2002 01:29'!
buildEnvelope
	| env |
	env := self envelope.
	env declareEncodingIn: SoapConstants soapEnvPrefix uri: self encodingStyleURIString.
	env declareTypicalNamespaces.
	self optionHeaderProperties isEmpty
		ifFalse: [ self buildSoapHeader: env addHeader.].
	env addBody.
	self buildSoapBody: env body.
	^env! !

!SoapCall methodsFor: 'building envelope' stamp: 'mu 7/30/2001 00:15'!
buildSoapBody: aSoapBody 
	| pref callElem |
	pref := self prefix.
	callElem := self xmlElementClass named: self methodName withPrefix: pref.
	callElem declareNamespace: pref uri: self namespace.
	self parameters
		do: [:each | callElem
				addChild: (each asXmlElement)].
	aSoapBody addBodyEntry: callElem.
	^ aSoapBody! !

!SoapCall methodsFor: 'building envelope' stamp: 'mu 7/16/2001 23:22'!
buildSoapHeader: aSoapHeader
	"##TODO: support additional header properties (like transaction id)"
	^aSoapHeader
	
	! !


!SoapCall methodsFor: 'testing' stamp: 'mu 6/7/2001 01:41'!
isCall
	^true! !


!SoapCall methodsFor: 'private' stamp: 'mu 12/19/2001 00:54'!
clear
	self optionHeaderProperties: nil.
	self envelope: nil.
	self context: nil.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapCall class
	instanceVariableNames: ''!

!SoapCall class methodsFor: 'instance creation' stamp: 'mu 6/5/2001 00:12'!
locator: aLocatorObject
	^self basicNew locator: aLocatorObject! !

!SoapCall class methodsFor: 'instance creation' stamp: 'mu 6/5/2001 00:17'!
new
	"default locator is SoapTcpLocator for localhost"
	^ self
		locator: (SoapTcpLocator host: 'localhost' port: 8823)! !

!SoapCall class methodsFor: 'instance creation' stamp: 'mu 12/28/2001 19:26'!
url: anURLString
	
	"host port transport targetObjectURI := self parseURL: anURLString"! !


SoapPRCElement subclass: #SoapResponse
	instanceVariableNames: 'returnValue outparameters fault exceptionBuilder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!
!SoapResponse commentStamp: '<historical>' prior: 0!
I represent a SOAP RPC response.

---
MU 5/12/2002 00:47!


!SoapResponse methodsFor: 'initialize-release' stamp: 'mu 10/27/2001 20:02'!
initialize: aSoapMessage
	self envelope: aSoapMessage envelope.
	self context: aSoapMessage context! !


!SoapResponse methodsFor: 'actions' stamp: 'mu 6/12/2001 22:00'!
isFault
	^self fault notNil! !

!SoapResponse methodsFor: 'actions' stamp: 'mu 11/10/2001 19:25'!
outparameters
	outparameters isNil ifTrue: [outparameters := self buildOutparameters].
	^outparameters! !

!SoapResponse methodsFor: 'actions' stamp: 'mu 11/24/2001 00:47'!
raiseException
	self isFault ifTrue: [self buildException signal].! !

!SoapResponse methodsFor: 'actions' stamp: 'mu 11/23/2001 23:57'!
returnValue
	self isFault ifTrue:[^nil].
	returnValue isNil ifTrue: [returnValue := self buildReturnValue].
	^returnValue! !


!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/24/2001 00:48'!
exceptionBuilder
	exceptionBuilder isNil ifTrue: [exceptionBuilder := SoapExceptionBuilder new].
	^exceptionBuilder! !

!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/24/2001 00:48'!
exceptionBuilder: aSoapExceptionBuilder
	exceptionBuilder := aSoapExceptionBuilder! !

!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/10/2001 19:08'!
fault
	fault isNil ifTrue: [fault := self envelope body fault].
	^fault! !

!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/24/2001 00:04'!
methodName
	(self isFault not
			and: [methodName isNil])
		ifTrue: [methodName := self envelope body bodyEntries first name copyReplaceAll: 'Responce' with: ''].
	^ methodName! !

!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/10/2001 19:49'!
targetObjectURI
	targetObjectURI isNil ifTrue: [targetObjectURI := self context targetObjectURI ].
	^targetObjectURI! !

!SoapResponse methodsFor: 'accessing' stamp: 'mu 11/24/2001 00:06'!
transport
	transport isNil ifTrue: [transport := self context at: #transport ifAbsent:[]].
	^transport! !


!SoapResponse methodsFor: 'testing' stamp: 'mu 6/7/2001 01:41'!
isResponse
	^true! !


!SoapResponse methodsFor: 'printing' stamp: 'mu 11/10/2001 20:55'!
printOn: aStream
	aStream nextPutAll: 'a ', self class name.
	aStream nextPutAll: ' ['.
	aStream nextPutAll: ' isFault= ', self isFault printString.
	aStream nextPutAll: ' methodName= ', self methodName printString.
	aStream nextPutAll: ' ]'.
	
	! !


!SoapResponse methodsFor: 'private' stamp: 'mu 11/24/2001 00:49'!
buildException
	
	^self exceptionBuilder buildExceptionFrom: self fault! !

!SoapResponse methodsFor: 'private' stamp: 'mu 11/10/2001 19:39'!
buildOutparameters
	| retValues sz outparams |
	retValues := self envelope body bodyEntries.
	sz := retValues size.
	sz <= 1
		ifTrue: [^ #()].
	outparams := OrderedCollection new.
	2
		to: sz
		do: [:idx | outparams
				add: (self
						extractDecodedValueFrom: (retValues at: idx))].
	^outparams! !

!SoapResponse methodsFor: 'private' stamp: 'MU 10/25/2002 00:34'!
buildReturnValue
	| retValueElem methodElem |
	methodElem := self envelope body bodyEntries first.
	retValueElem := methodElem findChildNamed: SoapConstants returnValueAccessor.
	retValueElem isNil
		ifTrue: [retValueElem := methodElem children isEmpty
						ifFalse: [methodElem children first]].
	^ self extractDecodedValueFrom: retValueElem! !

!SoapResponse methodsFor: 'private' stamp: 'mu 1/1/2002 21:35'!
extractDecodedValueFrom: aSoapWrapElement
	| decoder |
	aSoapWrapElement isNil ifTrue:[^nil].
	decoder := SoapDecoderFactory createFrom: aSoapWrapElement encodingStyleURIs.
	^decoder decodeXmlElement: aSoapWrapElement! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapResponse class
	instanceVariableNames: ''!

!SoapResponse class methodsFor: 'instance creation' stamp: 'mu 11/3/2001 21:58'!
fromSoapMessage: aSoapMessage
	^self new initialize: aSoapMessage
	! !


SoapEncodable subclass: #SoapVariable
	instanceVariableNames: 'name type id href value xsdType namespace '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-RPC'!
!SoapVariable commentStamp: '<historical>' prior: 0!
I represent a SOAP RPC variable. Used as parameter and return value.

---
MU 5/12/2002 00:47!


!SoapVariable methodsFor: 'accessing' stamp: 'MU 1/8/2003 00:02'!
href
	^href! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 1/8/2003 00:02'!
href: aValue

	href := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 1/7/2003 23:57'!
id
	^id! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 1/7/2003 23:56'!
id: aValue

	id := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:41'!
name

	^name! !

!SoapVariable methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:41'!
name: aValue

	name := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 8/5/2002 22:34'!
namespace

	^namespace! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 8/5/2002 22:34'!
namespace: aValue

	namespace := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:41'!
type

	^type! !

!SoapVariable methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:41'!
type: aValue

	type := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 4/18/2003 16:56'!
value
	self isReferredValue ifTrue: [^nil].
	^value! !

!SoapVariable methodsFor: 'accessing' stamp: 'mu 5/26/2001 01:41'!
value: aValue

	value := aValue! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 4/20/2002 23:16'!
xsdType

	^xsdType! !

!SoapVariable methodsFor: 'accessing' stamp: 'MU 4/20/2002 23:16'!
xsdType: aValue

	xsdType := aValue! !


!SoapVariable methodsFor: 'converting' stamp: 'mu 8/5/2001 00:31'!
asXmlElement
	| elem |
	elem := self encoder encodeSoapVariable: self.
	(self parent isNil or:[ self parent encoder class ~= self encoder class])
		ifTrue: [elem declareEncodingIn: SoapConstants soapEnvPrefix uri: self encodingStyleURIString].
	^elem! !


!SoapVariable methodsFor: 'actions' stamp: 'MU 1/8/2003 01:57'!
storeId
	id isNil ifTrue: [id := self generateId]! !


!SoapVariable methodsFor: 'testing' stamp: 'MU 4/18/2003 16:47'!
isReferredValue
	^self href notNil! !


!SoapVariable methodsFor: 'private' stamp: 'MU 1/8/2003 02:00'!
generateId
	id := (Random new next * 1000000) truncated printString.
	^id! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapVariable class
	instanceVariableNames: ''!

!SoapVariable class methodsFor: 'instance creation' stamp: 'mu 1/27/2002 01:56'!
name: aNameSymbol
	^ self name: aNameSymbol value: nil type: nil! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 1/8/2003 02:01'!
name: aNameSymbol href: aSoapVariable
	aSoapVariable storeId.
	^ self new name: aNameSymbol;
		 href: '#', aSoapVariable id.! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 5/11/2002 00:45'!
name: aNameSymbol type: aSmalltalkTypeSymbol
	^ self new name: aNameSymbol;
		 type: aSmalltalkTypeSymbol! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'mu 6/13/2001 01:00'!
name: aNameSymbol value: anObject
	^ self new name: aNameSymbol;
		value: anObject! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'mu 8/20/2001 02:23'!
name: aNameSymbol value: anObject type: aSmalltalkTypeSymbol
	^ self new name: aNameSymbol;
		value: anObject;
		 type: aSmalltalkTypeSymbol! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 4/20/2002 23:16'!
name: aNameSymbol value: anObject xsdType: anXsdTypeSymbol
	^ self new name: aNameSymbol;
		value: anObject;
		 xsdType: anXsdTypeSymbol! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 8/6/2002 00:05'!
name: aNameSymbol value: anObject xsdType: anXsdTypeSymbol namespace: namespaceURI 
	^ self new name: aNameSymbol;
		 value: anObject;
		 xsdType: anXsdTypeSymbol;
		 namespace: namespaceURI! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 5/11/2002 00:44'!
name: aNameSymbol xsdType: anXsdTypeSymbol
	^ self new name: aNameSymbol;
		 xsdType: anXsdTypeSymbol! !

!SoapVariable class methodsFor: 'instance creation' stamp: 'MU 8/6/2002 00:05'!
name: aNameSymbol xsdType: anXsdTypeSymbol namespace: namespaceURI 
	^ self new name: aNameSymbol;
		 xsdType: anXsdTypeSymbol;
		 namespace: namespaceURI! !

SoapCallEntry initialize!
SoapPRCElement initialize!