Object subclass: #SoConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoConstants commentStamp: '<historical>' prior: 0!
Abstract Constants provider.

---
mu 5/3/2001 19:22!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoConstants class
	instanceVariableNames: 'constDict '!

!SoConstants class methodsFor: 'class initialization' stamp: 'mu 6/27/2001 23:31'!
initialize
	"SoConstants initialize"
	constDict := nil! !


!SoConstants class methodsFor: 'private' stamp: 'mu 6/27/2001 23:29'!
at: aKey ifAbsentPutValue: aValue
	^self constDict at: aKey ifAbsent:[self constDict at: aKey put: aValue]! !


!SoConstants class methodsFor: 'accessing' stamp: 'mu 6/27/2001 23:22'!
constDict
	constDict isNil
		ifTrue: [constDict := (super canUnderstand: #constDict)
						ifTrue: [super constDict copy]
						ifFalse: [IdentityDictionary new]].
	^ constDict! !


Object subclass: #SoPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoPortableUtil commentStamp: '<historical>' prior: 0!
An utility for providing adapter interfaces for various Smalltalk implementations. 

Currently I support Squeak only.

If you would like to use other Smalltalks, you should subclass me.


---
mu 5/3/2001 19:23!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoPortableUtil class
	instanceVariableNames: ''!

!SoPortableUtil class methodsFor: 'actions' stamp: 'mu 8/5/2001 02:23'!
isBlank: aString 
	"##ANSI ST specific##"
	^(aString allSatisfy: [:i | i isSeparator])! !

!SoPortableUtil class methodsFor: 'actions' stamp: 'mu 1/1/2002 21:08'!
relativeURIFrom: aString 
	"Does this really work?"
	"##Squeak specific##"
	| uriStr colonIdx schemeName slashIdx |
	aString isEmpty ifTrue: [^aString].
	uriStr := aString last = $/
				ifTrue: [aString copyFrom: 1 to: aString size - 1]
				ifFalse: [aString].
	colonIdx := uriStr
				indexOf: $:
				ifAbsent: [^ uriStr].
	schemeName := aString copyFrom: 1 to: colonIdx - 1.
	(schemeName
			allSatisfy: [:each | each isLetter])
		ifTrue: [uriStr := uriStr copyFrom: colonIdx + 1 to: uriStr size].
	((uriStr at: 1)
				= $/
			and: [(uriStr at: 2)
					= $/])
		ifTrue: [uriStr := uriStr copyFrom: 2 to: uriStr size].
	slashIdx := uriStr findString: '/' startingAt: 2.
	slashIdx = 0
		ifFalse: [uriStr := uriStr copyFrom: slashIdx to: uriStr size].
	^ uriStr! !

!SoPortableUtil class methodsFor: 'actions' stamp: 'mu 9/7/2003 20:01'!
stackTraceFrom: anError
	| ctx |
	ctx := [anError signalerContext shortStack] on: Error do: [:ex | ex return: ''].
	^ctx! !

!SoPortableUtil class methodsFor: 'actions' stamp: 'mu 5/6/2001 01:57'!
substringsFrom: aString 
	"ToDo: Support other Smalltalks"
	"##Squeak specific##"
	aString isNil ifTrue: [^#()].
	^ aString substrings! !


Object subclass: #SoXmlAttributesHolder
	instanceVariableNames: 'namespaceDict otherDict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoXmlAttributesHolder commentStamp: '<historical>' prior: 0!
An utitily class for XML attribute handling.
	
---	
mu 5/3/2001 19:22!


!SoXmlAttributesHolder methodsFor: 'initialize-release' stamp: 'mu 4/15/2001 01:08'!
initialize
	namespaceDict :=  Dictionary new.
	otherDict := Dictionary new.! !


!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 8/12/2001 20:50'!
asDictionary
	| dict |
	dict := Dictionary new.
	self namespaceDict
		keysAndValuesDo: [:k :v | dict at: k put: v].
	self otherDict
		keysAndValuesDo: [:k :v | dict at: k put: v].
	^ dict! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 8/12/2001 20:53'!
declareNamespace: prefix uri: uri
	self namespaceDict at: SoXmlConstants xmlnsPrefixColon, prefix put: uri! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 8/20/2001 01:44'!
declaredNamespacePrefixes
	^ self namespaceDict keys
		collect: [:each | each copyFrom: SoXmlConstants xmlnsPrefixColon size + 1 to: each size]! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 9/18/2001 19:09'!
declaredNamespaceURIFor: prefix
	^self declaredNamespaceURIFor: prefix ifAbsent: []! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 9/18/2001 19:20'!
declaredNamespaceURIFor: prefix ifAbsent: aBlock
	^self namespaceDict at: (SoXmlConstants xmlnsPrefixColon, prefix) ifAbsent: aBlock! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'MU 3/31/2002 20:17'!
getAttributeLike: aNameString 
	| key |
	key := (self otherDict keys detect: [:each | aNameString match: each] ifNone:[] ).
	key isNil ifTrue: [key := self namespaceDict keys detect: [:each | aNameString match: each] ifNone:[]].
	^self getAttributeNamed: key! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 8/20/2001 00:07'!
getAttributeNamed: aNameString 
	^ self otherDict
		at: aNameString
		ifAbsent: [self namespaceDict
				at: aNameString
				ifAbsent: []]! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'MU 3/31/2002 20:05'!
hasAttributeLike: aNameString 
	^ ((self otherDict keys detect: [:each | aNameString match: each] ifNone:[nil]) notNil)
		or: [(self namespaceDict keys detect: [:each | aNameString match: each] ifNone:[nil]) notNil]! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'MU 3/24/2002 00:10'!
hasAttributeNamed: aNameString 
	^ (self otherDict includesKey: aNameString)
		or: [self namespaceDict includesKey: aNameString]! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 4/15/2001 00:44'!
putAttribute: aNameValueArray
	self putAttributeNamed: aNameValueArray first asString value: aNameValueArray last asString! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 8/20/2001 01:46'!
putAttributeNamed: attribName value: attribValue 
	| xmlns |
	xmlns := SoXmlConstants xmlnsPrefixColon.
	(attribName size > xmlns size
			and: [(attribName copyFrom: 1 to: xmlns size)
					= xmlns])
		ifTrue: [self namespaceDict at: attribName put: attribValue]
		ifFalse: [self otherDict at: attribName put: attribValue]! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'mu 5/3/2001 02:46'!
removeAttributeNamed: aNameString
	^self otherDict removeKey: aNameString! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'MU 4/27/2002 01:24'!
trimAttributePrefixNamed: attribName
	| value newKey |
	value := self otherDict at: attribName ifAbsent:[].
	value isNil ifTrue: [^nil].
	newKey := (SoXmlUtil prefixAndLocalNameFrom: attribName) last. 
	self removeAttributeNamed: attribName.
	^ self putAttributeNamed: newKey value: value
		! !

!SoXmlAttributesHolder methodsFor: 'actions' stamp: 'MU 4/27/2002 00:26'!
undeclareNamespaces
	namespaceDict := Dictionary new! !


!SoXmlAttributesHolder methodsFor: 'printing' stamp: 'mu 4/15/2001 01:47'!
printOn: aStream
	"super printOn: aStream." "for Debug"
	self printXmlOn: aStream! !

!SoXmlAttributesHolder methodsFor: 'printing' stamp: 'mu 8/12/2001 20:50'!
printXmlOn: aStream
	self namespaceDict keysAndValuesDo:[ :k :v |
		aStream nextPut: Character space.
		self writeName: k on: aStream.
		aStream nextPutAll: '="'.
		self writeValue: v asString on: aStream.
		aStream nextPut: $".
	].
	self otherDict keysAndValuesDo:[ :k :v |
		aStream nextPut: Character space.
		self writeName: k on: aStream.
		aStream nextPutAll: '="'.
		self writeValue: v asString on: aStream.
		aStream nextPut: $".
	]! !


!SoXmlAttributesHolder methodsFor: 'private' stamp: 'mu 4/15/2001 00:49'!
writeName: aCharacterArray on: aStream 
	"TODO: check illegal characters"
	^ aStream nextPutAll: aCharacterArray! !

!SoXmlAttributesHolder methodsFor: 'private' stamp: 'mu 4/15/2001 00:51'!
writeValue: aCharacterArray on: aStream 
	^SoXmlUtil writeXmlText: aCharacterArray on: aStream! !


!SoXmlAttributesHolder methodsFor: 'accessing' stamp: 'mu 4/15/2001 01:01'!
namespaceDict
	^namespaceDict! !

!SoXmlAttributesHolder methodsFor: 'accessing' stamp: 'mu 4/15/2001 00:58'!
otherDict
	^otherDict! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoXmlAttributesHolder class
	instanceVariableNames: ''!

!SoXmlAttributesHolder class methodsFor: 'instance creation' stamp: 'mu 4/15/2001 00:32'!
new
	^super new initialize! !


SoConstants subclass: #SoXmlConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoXmlConstants commentStamp: '<historical>' prior: 0!
XML Constants provider.

(I hate to use Pool)
---
mu 5/3/2001 19:22!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoXmlConstants class
	instanceVariableNames: ''!

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 6/27/2001 23:39'!
xmlnsURI
	^self at: #xmlnsURI ifAbsentPutValue: 'http://www.w3.org/2000/xmlns/'! !

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 6/28/2001 00:53'!
xmlnsURI: aString
	^self constDict at: #xmlnsURI put: aString! !

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 12/31/2001 01:29'!
xsdURI
	^self at: #xsdURI ifAbsentPutValue: 'http://www.w3.org/2001/XMLSchema'! !

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 6/28/2001 00:53'!
xsdURI: aString 
	^self constDict at: #xsdURI put: aString! !

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 12/31/2001 01:35'!
xsiURI
	^self at: #xsiURI ifAbsentPutValue: 'http://www.w3.org/2001/XMLSchema-instance'! !

!SoXmlConstants class methodsFor: 'URIs' stamp: 'mu 6/28/2001 00:53'!
xsiURI: aString
	^self constDict at: #xsiURI put: aString! !


!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 6/27/2001 23:45'!
xmlnsPrefix
	^self at: #xmlnsPrefix ifAbsentPutValue: 'xmlns'! !

!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 4/15/2001 00:38'!
xmlnsPrefixColon
	^self withColon: self xmlnsPrefix! !

!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 6/13/2001 00:23'!
xsdPrefix
	^self at: #xsdPrefix ifAbsentPutValue: 'xsd'! !

!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 4/15/2001 00:38'!
xsdPrefixColon
	^self withColon: self xsdPrefix! !

!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 6/13/2001 00:23'!
xsiPrefix
	^self at: #xsiPrefix ifAbsentPutValue: 'xsi'! !

!SoXmlConstants class methodsFor: 'prefixes' stamp: 'mu 4/15/2001 00:38'!
xsiPrefixColon
	^self withColon: self xsiPrefix! !


!SoXmlConstants class methodsFor: 'attributes' stamp: 'MU 3/23/2002 23:51'!
xsiType
	"shortcut for performance"
	^self at: #xsiType ifAbsentPutValue: (self xsiPrefixColon, 'type')! !


!SoXmlConstants class methodsFor: 'utility' stamp: 'mu 4/15/2001 00:38'!
withColon: aString
	| wStr |
	wStr := WriteStream on: (String new: aString size).
	wStr nextPutAll: aString.
	wStr nextPut: $:.
	^wStr contents.! !


!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:08'!
anyType
	^self at: #anyType ifAbsentPutValue: 'anyType'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:11'!
base64
	^self at: #base64 ifAbsentPutValue: 'base64'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:11'!
base64Binary
	^self at: #base64Binary ifAbsentPutValue: 'base64Binary'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:12'!
float
	^self at: #float ifAbsentPutValue: 'float'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:12'!
integer
	^self at: #integer ifAbsentPutValue: 'integer'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:11'!
string
	^self at: #string ifAbsentPutValue: 'string'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:14'!
time
	^self at: #time ifAbsentPutValue: 'time'! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 3/25/2002 01:04'!
xsdAnyType
	^self at: #xsdAnyType ifAbsentPutValue: (self xsdPrefixColon, 'anyType')! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:09'!
xsdBase64BinaryType
	^self at: #xsdBase64Binary ifAbsentPutValue: (self xsdPrefixColon, 'base64Binary')! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 4/21/2002 01:43'!
xsdFloatType
	^self at: #xsdFloatType ifAbsentPutValue: (self xsdPrefixColon, 'float')! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 4/21/2002 01:42'!
xsdIntegerType
	^self at: #xsdIntegerType ifAbsentPutValue: (self xsdPrefixColon, 'integer')! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 4/21/2002 01:41'!
xsdStringType
	^self at: #xsdStringType ifAbsentPutValue: (self xsdPrefixColon, 'string')! !

!SoXmlConstants class methodsFor: 'xsd types' stamp: 'MU 5/11/2002 03:13'!
xsdTimeType
	^self at: #xsdTime ifAbsentPutValue: (self xsdPrefixColon, 'time')! !


Object subclass: #SoXmlUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoXmlUtil commentStamp: '<historical>' prior: 0!
An utility for XML processing.
It includes:
	-Parsing XML
	-Writing XML text

I assume you have VWXMLParser.
If you would like to use other XML parsers, you should subclass me.


---
mu 5/3/2001 19:23!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoXmlUtil class
	instanceVariableNames: 'convertCharDict parserAdapter '!

!SoXmlUtil class methodsFor: 'class initialization' stamp: 'MU 5/14/2002 00:16'!
initialize
	"SoXmlUtil initialize"
	self initConvertCharDict.
	parserAdapter := nil
	
	! !


!SoXmlUtil class methodsFor: 'accessing' stamp: 'mu 3/27/2001 00:52'!
convertCharDict
	^convertCharDict! !

!SoXmlUtil class methodsFor: 'accessing' stamp: 'mu 2/7/2002 18:23'!
parserAdapter
	parserAdapter ifNil:[self initParserAdapter]. 
	^parserAdapter! !

!SoXmlUtil class methodsFor: 'accessing' stamp: 'mu 1/19/2002 03:46'!
parserAdapter: xmlParserAdapter
	parserAdapter := xmlParserAdapter! !


!SoXmlUtil class methodsFor: 'private-initialize' stamp: 'MU 4/18/2003 16:36'!
initConvertCharDict
	convertCharDict := Dictionary new.
	0 to: 47 do: [:each | convertCharDict at: each put: '&#', each asString, ';'].
	convertCharDict 
		at: $& asciiValue put: '&amp;';
		at: $< asciiValue put: '&lt;';
		at: $> asciiValue put: '&gt;';
		at: $' asciiValue put: '&apos;';
		at: $" asciiValue put: '&quot;'.
	convertCharDict 
		removeKey: Character space asciiValue;
		removeKey: Character tab asciiValue;
		removeKey: Character cr asciiValue;
		removeKey: Character lf asciiValue.
	convertCharDict 
		removeKey: $/ asciiValue;
		removeKey: $- asciiValue;
		removeKey: $# asciiValue;
		removeKey: $. asciiValue.! !

!SoXmlUtil class methodsFor: 'private-initialize' stamp: 'MU 5/14/2002 00:18'!
initParserAdapter
	"Currently YAXO and VWXML conscious"
	parserAdapter := self environment
				at: #SoYaxXMLParserAdapter
				ifAbsent: [self environment
						at: #SoVWXMLParserAdapter
						ifAbsent: [Transcript cr; show: '##failed to initParserAdapter##']]! !


!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 01:59'!
attribDictFrom: aParsedXMLElement
	^self parserAdapter attribDictFrom: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 01:59'!
elementNameFrom: aParsedXMLElement
	^self parserAdapter elementNameFrom: aParsedXMLElement
	! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:01'!
elementShortNameFrom: aParsedXMLElement
	^self parserAdapter elementShortNameFrom: aParsedXMLElement
	! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:02'!
elementValueFrom: aParsedXMLElement
	^self parserAdapter elementValueFrom: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:02'!
elementsFrom: aParsedXMLElement
	^self parserAdapter elementsFrom: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:03'!
elementsWithoutBlankTextsFrom: aParsedXMLElement
	^self parserAdapter elementsWithoutBlankTextsFrom: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:02'!
elementsWithoutTextsFrom: aParsedXMLElement
	^self parserAdapter elementsWithoutTextsFrom: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:01'!
isTextElement: aParsedXMLElement
	^self parserAdapter isTextElement: aParsedXMLElement! !

!SoXmlUtil class methodsFor: 'actions-parse' stamp: 'mu 1/17/2002 02:01'!
parseXml: xmlString
	^self parserAdapter parseXml: xmlString
	! !


!SoXmlUtil class methodsFor: 'actions' stamp: 'mu 4/9/2001 00:09'!
asXmlText: aString 
	|  wStr |
	wStr := WriteStream
				on: (String new: aString size).
	^(self writeXmlText: aString on: wStr) contents! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'mu 12/31/2001 01:12'!
contentsWithXmlDeclaration: aString 
	| wStr |
	wStr := WriteStream on: (String new: 1024).
	wStr nextPutAll: '<?xml version="1.0" encoding="utf-8"?>'.
	2timesRepeat: [wStr nextPut: Character cr.
			wStr nextPut: Character lf].
	wStr nextPutAll: aString.
	^wStr contents.! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'MU 4/28/2002 01:56'!
localNameFrom: aString 
	^(self prefixAndLocalNameFrom: aString) last! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'mu 1/16/2002 01:55'!
prefixAndLocalNameFrom: aString 
	| index readStream prefixName localName |
	index := aString indexOf: $:.
	index = 0
		ifTrue: [prefixName := ''.
			localName := aString]
		ifFalse: [readStream := aString readStream.
			prefixName := readStream next: index - 1.
			readStream skip: 1.
			localName := readStream next: aString size - index].
	^ Array with: prefixName with: localName! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'MU 8/5/2002 22:53'!
prefixFrom: aString 
	^(self prefixAndLocalNameFrom: aString) first! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'MU 8/5/2002 23:20'!
randomPrefix
	^'ns', (Random new nextInt: 100000000) printString
	! !

!SoXmlUtil class methodsFor: 'actions' stamp: 'MU 10/15/2002 01:04'!
writeXmlText: aString on: aWriteStream
	| cDict wStr contentStr |
	cDict := self convertCharDict.
	wStr := aWriteStream.
	contentStr := aString asString.
	contentStr
		do: [:eachChar | 
			| val | 
			val := eachChar asciiValue.
			val >= 127
				ifTrue: [wStr nextPutAll: '&#';
						 nextPutAll: val asString;
						 nextPut: $;]
				ifFalse: [| conv | 
					conv := cDict
								at: val
								ifAbsent: [].
					conv isNil
						ifTrue: [wStr nextPut: eachChar]
						ifFalse: [wStr nextPutAll: conv]]].
	^wStr! !


Object subclass: #SoXmlWrapElement
	instanceVariableNames: 'prefixName localName name value attributesHolder children parent isEmptyBody isPrintCDATA '
	classVariableNames: 'IsPrintCDATA '
	poolDictionaries: ''
	category: 'SoXML-Base'!
!SoXmlWrapElement commentStamp: '<historical>' prior: 0!
Representing an XML element.
Using XmlUtil, I am independent of XML parser implementations.

--
mu 5/3/2001 19:28!


!SoXmlWrapElement methodsFor: 'initialize-release' stamp: 'mu 4/14/2001 21:53'!
initialize
	isEmptyBody := false.
! !


!SoXmlWrapElement methodsFor: 'private-init' stamp: 'mu 8/5/2001 01:24'!
initAttributesBy: aDictionary
	aDictionary keysAndValuesDo:[:k :v |
		self putAttributeNamed: k value: v.
	].
	! !

!SoXmlWrapElement methodsFor: 'private-init' stamp: 'mu 1/16/2002 01:57'!
initByDom: aParsedXmlElement 
	| prefixAndLocalName |
	self
		name: (SoXmlUtil elementNameFrom: aParsedXmlElement).
	prefixAndLocalName := SoXmlUtil prefixAndLocalNameFrom: self name.
	self prefixName: prefixAndLocalName first.
	self localName: prefixAndLocalName last.
	self
		initAttributesBy: (SoXmlUtil attribDictFrom: aParsedXmlElement).
	self
		value: (SoXmlUtil elementValueFrom: aParsedXmlElement).

	(SoXmlUtil elementsWithoutBlankTextsFrom: aParsedXmlElement)
		do: [:each | self initChildElementByDom: each]! !

!SoXmlWrapElement methodsFor: 'private-init' stamp: 'MU 3/24/2002 02:11'!
initChildElementByDom: aParsedXmlElement 
	| parentElem childElmClass child |
	(SoXmlUtil isTextElement: aParsedXmlElement)
		ifTrue: [^ self
				value: (SoXmlUtil elementValueFrom: aParsedXmlElement)].
	parentElem := SoXmlUtil elementNameFrom: aParsedXmlElement.
	childElmClass := self privElementClassFrom: parentElem.
	child := childElmClass fromXmlElement: aParsedXmlElement.
	self addChild: child! !


!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 6/7/2001 01:44'!
addChild: anXMLEleemnt
	anXMLEleemnt isNil ifTrue:[^nil].
	anXMLEleemnt parent: self.
	^self children add: anXMLEleemnt.
	! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 9/18/2001 19:27'!
allDeclaredNamespacePrefixes
	^ self attributesHolder declaredNamespacePrefixes isEmpty
		ifTrue: [self parent notNil
				ifTrue: [self parent declaredNamespacePrefixes]]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 9/18/2001 19:27'!
allDeclaredNamespaceURIFor: prefix 
	^ self attributesHolder
		declaredNamespaceURIFor: prefix
		ifAbsent: [self parent notNil
				ifTrue: [self parent declaredNamespaceURIFor: prefix]]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 8/12/2001 19:32'!
attributesDictionary
	^self attributesHolder asDictionary! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 6/10/2000 20:18'!
beEmpty
	self isEmptyBody: true
	! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 4/27/2002 00:19'!
beShortName
	self name: self shortName! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 4/9/2001 00:06'!
createChildNamed: anElemName
	| child |
	child := self class named: anElemName.
	self addChild: child.
	^child! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 4/9/2001 00:06'!
createParentNamed: anElemName
	| pa |
	pa := self class named: anElemName.
	pa addChild: self.
	^pa! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 02:50'!
declareNamespace: prefix uri: uri
	self attributesHolder declareNamespace: prefix uri: uri! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 9/18/2001 19:27'!
declaredNamespacePrefixes
	^ self attributesHolder declaredNamespacePrefixes ! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 9/18/2001 19:27'!
declaredNamespaceURIFor: prefix 
	^ self attributesHolder declaredNamespaceURIFor: prefix
		! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 1/14/2002 02:42'!
findChild: aBlock
	^self children detect: aBlock ifNone:[]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 1/16/2002 01:59'!
findChildLocalNamed: anElemName
	^self children detect: [:each | each localName = anElemName] ifNone:[]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 2/13/2000 02:18'!
findChildNamed: anElemName
	^self children detect: [:each | each name = anElemName] ifNone:[]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 1/14/2002 02:43'!
findChildren: aBlock
	^self children select: aBlock! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 1/16/2002 02:00'!
findChildrenLocalNamed: anElemName
	^self children select: [:each | each localName = anElemName]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 2/13/2000 02:21'!
findChildrenNamed: anElemName
	^self children select: [:each | each name = anElemName]! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 1/27/2002 02:18'!
firstChild
	^self children first! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 3/31/2002 20:18'!
getAttributeLike: aNameString
	^self attributesHolder getAttributeLike: aNameString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 02:43'!
getAttributeNamed: aNameString
	^self attributesHolder getAttributeNamed: aNameString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 3/31/2002 20:09'!
hasAttributeLike: aNameString
	^self attributesHolder hasAttributeLike: aNameString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 3/24/2002 00:18'!
hasAttributeNamed: aNameString
	^self attributesHolder hasAttributeNamed: aNameString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 6/10/2000 19:50'!
putAttribute: aNameValueArray
	
	self putAttributeNamed: aNameValueArray first asString value: aNameValueArray last asString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 02:45'!
putAttributeNamed: aNameString value: aValueString
	^self attributesHolder putAttributeNamed: aNameString value: aValueString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 5/3/2001 02:46'!
removeAttributeNamed: aNameString
	^self attributesHolder removeAttributeNamed: aNameString! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 6/7/2001 01:44'!
removeChild: anXMLEleemnt
	^self children remove: anXMLEleemnt ifAbsent:[nil].
	! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'mu 9/24/2001 02:14'!
shortName
	| nm idx sz |
	nm := self name.
	idx := nm indexOf: $: ifAbsent: [^nm].
	sz := nm size.
	idx > sz ifTrue:[^nm].
	^nm copyFrom: idx + 1 to: sz! !

!SoXmlWrapElement methodsFor: 'actions' stamp: 'MU 4/27/2002 00:26'!
undeclareNamespaces
	self attributesHolder undeclareNamespaces! !


!SoXmlWrapElement methodsFor: 'sorting' stamp: 'mu 4/11/2001 01:15'!
privSortChildren: aCollectionOfXmlElement
	"default do nothing"
	^aCollectionOfXmlElement! !


!SoXmlWrapElement methodsFor: 'printing' stamp: 'MU 6/11/2000 01:06'!
printOn: aStream
	"super printOn: aStream" "for Debug"
	self printXmlOn: aStream! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'mu 12/31/2001 02:19'!
printXmlContentsOn: aStream indent: level 
	self isEmptyBody
		ifFalse: 
			[self value isNil ifFalse: [self privPrintXmlContentOn: aStream ].
			children isNil ifFalse:["ugly - but for performance"
			aStream cr.
			self privPrintChildrenOn: aStream indent: level + 1.
			level timesRepeat: [aStream space]]].! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'mu 4/14/2001 20:28'!
printXmlFooterOn: aStream 
	self isXmlPrintable ifFalse: [^ self].
	self isEmptyBody
		ifFalse: 
			[aStream nextPut: $<.
			aStream nextPut: $/.
			self writeName: self name on: aStream.
			aStream nextPut: $>].! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'mu 4/14/2001 20:28'!
printXmlHeaderOn: aStream 
	self isXmlPrintable ifFalse: [^ self].
	self isEmptyBody
		ifTrue: 
			[aStream nextPut: $<.
			self writeName: self name on: aStream.
			self privPrintAttribsOn: aStream.
			aStream nextPut: $/.
			aStream nextPut: $>]
		ifFalse: 
			[aStream nextPut: $<.
			self writeName: self name on: aStream.
			self privPrintAttribsOn: aStream.
			aStream nextPut: $>.].! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'MU 4/7/2000 18:28'!
printXmlOn: aStream 
	self printXmlOn: aStream indent: 0! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'mu 4/14/2001 21:44'!
printXmlOn: aStream indent: level 
	self isXmlPrintable
		ifFalse: [^ self].
	level
		timesRepeat: [aStream space].
	self printXmlHeaderOn: aStream.
	self printXmlContentsOn: aStream indent: level.
	self printXmlFooterOn: aStream.
	aStream cr! !

!SoXmlWrapElement methodsFor: 'printing' stamp: 'mu 6/28/2001 01:33'!
xmlString
	| wStr |
	wStr := WriteStream on: (String new: 64).
	self printXmlOn: wStr.
	^wStr contents! !


!SoXmlWrapElement methodsFor: 'private' stamp: 'MU 6/11/2000 01:53'!
isXmlPrintable
	^self name notNil! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'MU 3/24/2002 02:11'!
privElementClassFrom: parentXmlElement
	"override to return apporopriate XmlWrapElement"
	^self class! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'mu 5/3/2001 02:45'!
privPrintAttribsOn: aStream
	attributesHolder isNil ifTrue:[^self]. "ugly - but for performance"
	self attributesHolder printXmlOn: aStream! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'mu 12/31/2001 02:16'!
privPrintChildrenOn: aStream indent: level
	(self privSortChildren: children) do:[ :each |
		each printXmlOn: aStream indent: level.
	]! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'mu 4/9/2001 00:19'!
privPrintXmlContentOn: aStream 
	self isPrintCDATA
		ifTrue: 
			[aStream nextPutAll: '<!![CDATA['.
			aStream nextPutAll: self value.
			aStream nextPutAll: ']]>']
		ifFalse: [self writeValue: self value on: aStream.].! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'mu 4/9/2001 00:31'!
writeName: aCharacterArray on: aStream 
	"TODO: check illegal characters"
	^ aStream nextPutAll: aCharacterArray! !

!SoXmlWrapElement methodsFor: 'private' stamp: 'mu 4/15/2001 00:52'!
writeValue: aCharacterArray on: aStream 
	^SoXmlUtil writeXmlText: aCharacterArray on: aStream! !


!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 5/3/2001 02:42'!
attributesHolder
	attributesHolder isNil ifTrue:[ attributesHolder := SoXmlAttributesHolder new].
	^attributesHolder! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 5/3/2001 02:43'!
attributesHolder: aValue

	attributesHolder := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 10/15/2002 00:57'!
basicValue: aValue 
	"Exceptional Use: For debugging or performance tuning"
	value := aValue ! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 02:30'!
children
	children isNil ifTrue:[ children := OrderedCollection new].
	^children! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 02:30'!
children: aValue
	
	children := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:56'!
isEmptyBody

	^isEmptyBody! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:56'!
isEmptyBody: aValue

	isEmptyBody := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 6/11/2000 20:09'!
isPrintCDATA
	isPrintCDATA isNil ifTrue:[ isPrintCDATA := self class isPrintCDATA].
	^isPrintCDATA! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 6/11/2000 20:09'!
isPrintCDATA: aValue

	isPrintCDATA := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 1/16/2002 01:59'!
localName

	^localName! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 1/16/2002 01:59'!
localName: aValue

	localName := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:29'!
name

	^name! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:29'!
name: aValue

	name := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:29'!
parent

	^parent! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:29'!
parent: aValue

	parent := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 1/16/2002 01:59'!
prefixName

	^prefixName! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 1/16/2002 01:59'!
prefixName: aValue

	prefixName := aValue! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'MU 2/13/2000 01:29'!
value

	^value! !

!SoXmlWrapElement methodsFor: 'accessing' stamp: 'mu 8/5/2001 02:09'!
value: aValue 
	aValue isNil
		ifTrue: [^ self].
	value := aValue asString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoXmlWrapElement class
	instanceVariableNames: ''!

!SoXmlWrapElement class methodsFor: 'from xml' stamp: 'mu 4/15/2001 00:52'!
fromXml: xmlString
	^self fromXmlElement: (SoXmlUtil parseXml: xmlString).! !

!SoXmlWrapElement class methodsFor: 'from xml' stamp: 'mu 8/5/2001 02:02'!
fromXmlElement: aParsedXmlElement
	^self new initByDom: aParsedXmlElement! !


!SoXmlWrapElement class methodsFor: 'instance creation' stamp: 'MU 6/10/2000 20:19'!
emptyNamed: anElemName
	^(self named: anElemName) beEmpty! !

!SoXmlWrapElement class methodsFor: 'instance creation' stamp: 'MU 2/13/2000 02:14'!
named: anElemName
	^self new name: anElemName! !

!SoXmlWrapElement class methodsFor: 'instance creation' stamp: 'mu 5/3/2001 02:51'!
named: anElemName withPrefix: prefix
	^self named: prefix, ':', anElemName! !

!SoXmlWrapElement class methodsFor: 'instance creation' stamp: 'MU 2/13/2000 01:20'!
new
	^super new initialize! !


!SoXmlWrapElement class methodsFor: 'accessing' stamp: 'mu 4/9/2001 00:33'!
isPrintCDATA
	IsPrintCDATA isNil ifTrue:[ IsPrintCDATA := false ].
	^IsPrintCDATA! !

!SoXmlWrapElement class methodsFor: 'accessing' stamp: 'MU 6/11/2000 20:15'!
isPrintCDATA: aBoolean
	IsPrintCDATA := aBoolean! !

SoConstants initialize!
SoXmlUtil initialize!