"Description: 
An install script for SoapOpera 0.6
Edit settings and file-in.

Copyright (C) 2002-2003 Masashi Umezawa

Prerequisites:
YAXO or VWXML
KomHttpServer (Comanche 6.2+)

##SoapOpera 0.6 runs on Squeak 3.6## 
##If you would like to use SoapOpera in older versions of Squeak, use SoapOpera 0.5##

How to install: 
0: Install prerequisites from SqueakMap.
1: Put the directory named: 'installSoapOpera0.6' under your Squeak home direcotry.
2: Edit settings below.
3: From the file list, just file in this file.

"!

"settings -  edit if you like"
dir := 'installSoapOpera0.6'.
soapInstall := true.
soapSrpEncInstall := false.
soapSqtpTransInstall := true.
operaInstall := true.
sixxInstall := true.
sixxEncInstall := true.

"install main - edit if you like (normally you don't have to)"
rootPath := (FileDirectory default fullNameFor: dir), FileDirectory slash.
soapPath := rootPath,'SoapCore'.
operaPath := rootPath,'OperaORB'.
sixxPath := rootPath, 'SIXX'.

soap := #(
'SoXML-Base.st'
'SoXML-ParserAdapter.st'
'SOAP-Base.st'
'SOAP-Elements.st'
'SOAP-DataBinding.st'
'SOAP-Encoding.st'
'SOAP-Decoding.st'
'SOAP-ClientBase.st'
'SOAP-ServerBase.st'
'SOAP-Http.st'
'SOAP-Http-Client.st'
'SOAP-Http-Comanche.st'
'SOAP-RPC.st'
'SOAP-Example.st'
'SOAP-GoogleWebAPI.st'
'SOAP-TestCases.st'
).

soapSrpEnc := #(
'SOAP-DataBinding-SRP.st'
'SOAP-TestCases-SRP.st'
).

soapSixxEnc := #(
'SOAP-DataBinding-SIXX.st'
'SOAP-TestCases-SIXX.st'
).

soapSqtpTrans := #(
'SOAP-Sqtp.st'
'SOAP-Sqtp-Client.st'
'SOAP-Sqtp-Server.st'
'SOAP-TestCases-Sqtp.st'
).


soapInstall ifTrue:[
soap do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

soapSrpEncInstall ifTrue:[
soapSrpEnc do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

soapSqtpTransInstall ifTrue:[
soapSqtpTrans do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

operaInstall ifTrue:[
((FileDirectory on: rootPath) readOnlyFileNamed: 'installOperaORB.st') fileIn.
].

sixxInstall ifTrue:[
((FileDirectory on: rootPath) readOnlyFileNamed: 'installSIXX.st') fileIn.
sixxEncInstall ifTrue: [soapSixxEnc do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.]].
].
!

"program initialization"

(Smalltalk includesKey: #VWXMLXMLParser) ifTrue:[
(self confirm: 'Do you use VWXML? (No means YAXO)')
	ifTrue: [SoXmlUtil parserAdapter: SoVWXMLParserAdapter ].
].
SoapConfigurationMap initializeAll.

self inform: 'SoapOpera0.6 installation succeeded'.
ChangeSet current name: 'SoapOpera0.6-20031010-all'.
! 

"end of script"!
